---
product: "AG Grid"
title: "Row Grouping - Editing Groups"
description: "The grid supports editing grouped data when using the . This page covers making group row cells editable, distributing edited values to descendant rows, and refreshing the grouping hierarchy after edits."
enterprise: true
framework: javascript
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping/"
    - title: "Grouping Data"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping-data/"
    - title: "Group Display Types"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping-display-types/"
    - title: "Row Group Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping-group-panel/"
    - title: "Expanding Groups"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping-opening-groups/"
    - title: "Hierarchy Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping-row-selection/"
    - title: "Sorting"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping-sorting/"
    - title: "Row Dragging"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping-row-dragging/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Row Grouping - Editing Groups

The grid supports editing grouped data when using the [Client-Side Row Model](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-models/#client-side). This page covers making group row cells editable, distributing edited values to descendant rows, and refreshing the grouping hierarchy after edits.

## Editing Group Row Cells

Set `groupRowEditable` on any column to make its group row cells editable. The grid then distributes the edited value to descendant rows using the built-in distribution. To customise this, set `groupRowValueSetter` to an options object, a callback, or `false` to disable distribution.

In the example below, double-click any group row's `Sales` cell to edit it. The new total spreads equally across the group's children, recursing through nested groups.

#### Built-in Sum Distribution

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingEditModule, RowGroupingModule } from "ag-grid-enterprise";
import { SalesRecord, getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
]);

let gridApi: GridApi<SalesRecord>;

const gridOptions: GridOptions<SalesRecord> = {
  columnDefs: [
    { field: "region", rowGroup: true, hide: true },
    { field: "country", rowGroup: true, hide: true },
    {
      headerName: "Sales",
      field: "sales",
      aggFunc: "sum",
      editable: true,

      // Enable editing on group rows and use the built-in distribution.
      // With 'sum' aggregation, the default strategy is 'uniform' — the new total
      // is divided equally among all children.
      // precision: 0 rounds values to integers and spreads the rounding remainder
      // across children so the total matches exactly.
      groupRowEditable: true,
      groupRowValueSetter: {
        precision: 0,
      },
    },
  ],
  autoGroupColumnDef: {
    minWidth: 220,
    cellRendererParams: { suppressCount: true },
  },
  defaultColDef: {
    flex: 1,
    sortable: true,
    filter: true,
    resizable: true,
  },
  rowData: getData(),
  groupDefaultExpanded: -1,
  getRowId: ({ data }) => data.id,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Built-in Sum Distribution](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/distribute-group-value-sum/typescript/)

`groupRowEditable` accepts a `boolean` or a callback. The callback runs only for group rows (`rowNode.group === true`); leaf rows continue to honour `editable`. When a column sets both properties, the grid uses whichever matches the current row type, allowing separate rules for group rows and leaf rows.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `groupRowEditable` | `boolean \| GroupRowEditableCallback` |  |  |  |
| `groupRowValueSetter` | `boolean \| GroupRowValueSetterFunc \| GroupRowValueSetterOptions` |  |  |  |

## Built-in Value Distribution

The built-in distribution adjusts each child so the column's `aggFunc` produces the new total. Pass an options object to `groupRowValueSetter` to customise the strategy or precision.

```js
const gridOptions = {
    columnDefs: [
        {
            field: 'sales',
            aggFunc: 'sum',
            editable: true,
            groupRowEditable: true,
            // Built-in distribution: divides the sum equally among children.
            // precision: 0 rounds child values to integers and spreads the remainder.
            groupRowValueSetter: { precision: 0 },
        },
    ],

    // other grid options ...
}
```

### Distribution Strategies

The `distribution` option controls how the edited value is spread across children. When omitted, the strategy is chosen automatically based on the column's `aggFunc`:

| Strategy | Behaviour | Default for |
| --- | --- | --- |
| `'uniform'` | Divides the new value equally among all children. | `sum` |
| `'overwrite'` | Writes the new value directly to every child. | `avg`, no aggFunc |
| `'percentage'` | Scales each child proportionally, preserving relative weights. Falls back to `'uniform'` when the current total is zero. | — |
| `'increment'` | Distributes only the difference (`newValue − oldValue`) among children, adding it to current values. | — |

Editing is **disabled by default** for `count`, `min`, `max`, `first`, `last`, and **custom aggregation functions**. These functions have no unique inverse, so the grid cannot choose a safe default. To enable editing for them:

- Set `distribution` to `'overwrite'` to write the new value directly to every child.
- Provide a per-aggFunc record entry with `'overwrite'`, `true`, or a custom callback (see [Per-Aggregation Strategies](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping-edit/#per-aggregation-strategies)).
- Assign a [callback](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping-edit/#custom-distribution-with-a-callback) to `groupRowValueSetter` for full control.

```js
const gridOptions = {
    columnDefs: [
        {
            field: 'price',
            aggFunc: 'min',
            editable: true,
            groupRowEditable: true,
            // 'overwrite' writes the edited value to every child
            groupRowValueSetter: { distribution: 'overwrite' },
        },
        {
            field: 'quantity',
            aggFunc: 'count',
            editable: true,
            groupRowEditable: true,
            // Per-aggFunc record: enable only count with overwrite
            groupRowValueSetter: { distribution: { count: 'overwrite' } },
        },
    ],

    // other grid options ...
}
```

Setting `distribution` to `true` uses built-in defaults for `sum`, `avg`, no-aggFunc columns, and custom aggregation functions. The `count`, `min`, `max`, `first`, and `last` functions stay disabled even with `true`; use `'overwrite'`, a per-aggFunc record entry, or a callback to enable them.

Setting `distribution` to `false` or `null` suppresses distribution and makes the cell not editable, even when `groupRowEditable` is `true`.

For `avg`, every strategy adjusts child values so the children's average equals the edited value.

> **Note**
>
> The `precision` option rounds the values written to **child rows**, not the group row's displayed value. The group value is re-computed by the column's `aggFunc` from the rounded children. For `sum` this is always exact. For `avg` the re-aggregated value may differ: distributing `precision: 0` across 3 children produces integers, but their average (`10 / 3 ≈ 3.33`) is not. Use a [Value Formatter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/value-formatters/) to control how the group row displays the re-aggregated value.

### Distribution Options

Properties available on the `GroupRowValueSetterOptions&lt;TData = any, TValue = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `distribution` | `Distribution` |  |  |  |
| `default` | `GroupRowValueSetterDistributionEntry` |  |  |  |
| `precision` | `number \| false` |  |  |  |
| `getValue` | `Function` |  |  |  |
| `setValue` | `Function` |  |  |  |

### Merging with Default Column Definitions

When `groupRowValueSetter` is set as an options object on both `defaultColDef` and a column, the grid deep merges the two. The column's properties take precedence; anything not specified on the column is inherited from the default. This includes nested `distribution` records.

```js
const gridOptions = {
    defaultColDef: {
        editable: true,
        groupRowEditable: true,
        // Default: round child values to integers, disable count
        groupRowValueSetter: { precision: 0, distribution: { count: false } },
    },
    columnDefs: [
        {
            field: 'sales',
            aggFunc: 'sum',
            // Column-level override: use percentage distribution.
            // precision: 0 is inherited from defaultColDef.
            groupRowValueSetter: { distribution: 'percentage' },
        },
        {
            field: 'quantity',
            aggFunc: 'count',
            // Override defaultColDef's false with true to enable editing for count.
            groupRowValueSetter: { distribution: { count: true } },
        },
        {
            field: 'profit',
            aggFunc: 'sum',
            // No column-level override — inherits { precision: 0 } from defaultColDef.
        },
    ],

    // other grid options ...
}
```

> **Note**
>
> Deep merging only applies when both the `defaultColDef` and the column define `groupRowValueSetter` as plain objects. If the column defines a callback function, it replaces the default entirely.

### Multiple Aggregation Functions

The following example mixes built-in strategies, a non-aggregated column, and custom callbacks. Double-click any group row cell to edit it:

- **Salary** (`sum`): divides the new total equally among children, rounded to integers (`precision: 0`). Editing 300 across 3 children produces 100 each.
- **Bonus** (`avg`): overwrites every child with the edited value. Editing the average to 15 sets all children's bonus to 15.
- **Projects** (no `aggFunc`): overwrites every child with the edited value. The group cell is blank but still editable.
- **Rate %** (custom callback): computes each leaf child's bonus as `salary × rate / 100`. Entering 20 sets each child's bonus to 20% of their salary. Uses `node.getAggregatedChildren(column, true)` to reach all descendant leaf rows directly.
- **SumSq** (custom `sumOfSquares` aggFunc): a callback sets each child to `√(newValue / count)`, the inverse of sum-of-squares.

#### Multiple Aggregation Functions

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  GroupRowValueSetterFunc,
  IAggFunc,
  IAggFuncParams,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingEditModule, RowGroupingModule } from "ag-grid-enterprise";
import { MetricsRecord, getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  TextFilterModule,
]);

let gridApi: GridApi<MetricsRecord>;

/** Custom aggregation function: sum of squares. */
const sumOfSquares: IAggFunc = (params: IAggFuncParams) => {
  let total = 0;
  for (const value of params.values) {
    const n = Number(value);
    if (Number.isFinite(n)) {
      total += n * n;
    }
  }
  return total;
};

/**
 * Custom groupRowValueSetter for sumOfSquares.
 *
 * Because sumOfSquares uses x² in its aggregation, the built-in strategies
 * (uniform, percentage, etc.) would not produce correct results.
 * Instead, we compute the square root to find the per-child value that
 * produces the desired aggregate: each child = √(newValue / count).
 */
const sumOfSquaresValueSetter: GroupRowValueSetterFunc<MetricsRecord> = ({
  newValue,
  aggregatedChildren,
  column,
}) => {
  const target = Number(newValue);
  const count = aggregatedChildren.length;
  if (!count || !Number.isFinite(target)) {
    return false;
  }
  const perChild = Math.round(Math.sqrt(Math.max(0, target / count)));
  let changed = false;
  for (const child of aggregatedChildren) {
    if (child.setDataValue(column, perChild, "data")) {
      changed = true;
    }
  }
  return changed;
};

/**
 * Cross-column groupRowValueSetter: editing the group row's "Rate %"
 * sets each leaf child's bonus to a percentage of their individual salary.
 *
 * Uses getAggregatedChildren with recursive=true to reach all descendant
 * leaf rows, since intermediate group rows don't have salary data.
 *
 * For example, entering 20 on the Engineering group sets each engineer's
 * bonus to 20% of their salary: Alice (salary 90) gets bonus 18,
 * Dave (salary 95) gets bonus 19, etc.
 */
const bonusRateSetter: GroupRowValueSetterFunc<MetricsRecord> = ({
  newValue,
  node,
  column,
}) => {
  const rate = Number(newValue) / 100;
  if (!Number.isFinite(rate)) {
    return false;
  }
  const leaves = node.getAggregatedChildren(column, true);
  if (!leaves.length) {
    return false;
  }
  let changed = false;
  for (const child of leaves) {
    const salary = child.data?.salary ?? 0;
    if (child.setDataValue("bonus", Math.round(salary * rate), "data")) {
      changed = true;
    }
  }
  return changed;
};

const gridOptions: GridOptions<MetricsRecord> = {
  columnDefs: [
    { field: "department", rowGroup: true, hide: true },
    { field: "team", rowGroup: true, hide: true },
    { field: "employee", minWidth: 120 },

    // sum: uniform distribution (divides equally), with integer rounding
    {
      field: "salary",
      aggFunc: "sum",
      groupRowValueSetter: { precision: 0 },
    },

    // avg: default strategy is 'overwrite' — sets every child to the edited value
    {
      field: "bonus",
      aggFunc: "avg",
      valueFormatter: ({ value }) =>
        value != null ? Number(value).toFixed(2) : "",
    },

    // No aggFunc: the default strategy is 'overwrite', writing the edited
    // value to every child. The group cell is blank (no aggregation) but
    // still editable via groupRowEditable.
    { field: "projects" },

    // Cross-column custom callback: editing the group row's "Rate"
    // reads each child's salary and writes a computed bonus.
    {
      headerName: "Rate %",
      valueGetter: ({ data }) =>
        data ? (data.bonus / data.salary) * 100 : null,
      valueFormatter: ({ value }) =>
        value != null ? Number(value).toFixed(2) : "",
      aggFunc: "avg",
      editable: false,
      groupRowEditable: true,
      groupRowValueSetter: bonusRateSetter,
    },

    // Custom aggregation function with a custom groupRowValueSetter
    {
      headerName: "SumSq",
      field: "score",
      aggFunc: "sumOfSquares",
      groupRowValueSetter: sumOfSquaresValueSetter,
    },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 120,
    sortable: true,
    filter: true,
    resizable: true,

    // Enable editing on all columns (leaf rows and group rows).
    // When groupRowEditable is defined, the built-in distribution
    // automatically uses the right strategy for each aggregation function.
    editable: true,
    groupRowEditable: true,
  },
  aggFuncs: {
    sumOfSquares,
  },
  autoGroupColumnDef: {
    minWidth: 200,
    cellRendererParams: { suppressCount: true },
  },
  rowData: getData(),
  groupDefaultExpanded: -1,
  getRowId: ({ data }) => data.id,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Multiple Aggregation Functions](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/distribute-group-value-all-agg/typescript/)

### Per-Aggregation Strategies

When several columns share a `groupRowValueSetter` (e.g. via `defaultColDef`) but use different aggregation functions, set `distribution` to a record keyed by `aggFunc` name. Each entry can be a strategy string, an options object, a custom callback, `true` for built-in defaults, or `false`/`null` to suppress distribution for that aggFunc:

```js
const myCustomAgg = (params) => {
    let total = 0;
    for (const value of params.values) {
        total += Number(value) || 0;
    }
    return total;
};

// Optional: inverse enables incremental aggregation on row changes
myCustomAgg.inverse = (params) => {
    let total = Number(params.result) || 0;
    for (const value of params.values) {
        total -= Number(value) || 0;
    }
    return total;
};

const gridOptions = {
    aggFuncs: {
        myCustomAgg,
    },
    defaultColDef: {
        editable: true,
        groupRowEditable: true,
        groupRowValueSetter: {
            precision: 0,
            distribution: {
                sum: 'percentage',                          // strategy string
                avg: { distribution: 'increment' },         // options object
                myCustomAgg: (params) => {                  // custom callback function
                    for (const child of params.aggregatedChildren) {
                        child.setDataValue(params.column, params.newValue, 'data');
                    }
                    return true;
                },
            },
        },
    },

    // other grid options ...
}
```

Custom aggregation functions are disabled by default. To enable editing, add an explicit entry in the `distribution` record. The entry can be a strategy string, an options object, or a callback that implements the inverse of the aggregation logic:

```js
const gridOptions = {
    defaultColDef: {
        editable: true,
        groupRowEditable: true,
        groupRowValueSetter: {
            precision: 0,
            distribution: {
                sum: 'percentage',
                avg: 'increment',
                count: 'overwrite',
                // Custom aggFunc: provide a callback that reverses the aggregation
                myCustomAgg: (params) => {
                    for (const child of params.aggregatedChildren) {
                        child.setDataValue(params.column, params.newValue, 'data');
                    }
                    return true;
                },
            },
        },
    },

    // other grid options ...
}
```

Aggregation functions not listed in the record fall through to the `default` fallback, then to the built-in defaults (see the strategy table above).

### Default Fallback

When multiple custom aggregation functions share the same distribution logic, the `default` property avoids repeating entries for each one. It applies to any aggregation function not explicitly listed in the `distribution` record, including custom aggregations (which are otherwise disabled) and columns with no `aggFunc` (which already default to `'overwrite'`). Non-distributable functions (`count`, `min`, `max`, `first`, `last`) are **not** affected by `default` and must always be listed explicitly.

```js
const gridOptions = {
    defaultColDef: {
        editable: true,
        groupRowEditable: true,
        groupRowValueSetter: {
            precision: 0,
            distribution: {
                sum: 'percentage',
                count: 'overwrite',
            },
            // Fallback for unlisted custom aggFuncs and no-aggFunc columns.
            default: 'overwrite',
        },
    },

    // other grid options ...
}
```

### Custom getValue and setValue

The `getValue` and `setValue` callbacks override how the built-in distributor reads from and writes to child rows. By default it uses `node.getDataValue(column, 'value')` to read and `node.setDataValue(column, value, 'data')` to write. Provide your own when child values live on a different field or custom data structure, when you need to apply transformations or side effects during distribution, or when the column's `valueGetter` / `valueSetter` are not suitable for distribution.

```js
const gridOptions = {
    columnDefs: [
        {
            field: 'amount',
            aggFunc: 'sum',
            editable: true,
            groupRowEditable: true,
            groupRowValueSetter: {
                distribution: 'percentage',
                getValue: (params) => (params.data && params.data.weight) || 0,
                setValue: (params) => params.node.setDataValue(params.column, params.value, 'data'),
            },
        },
    ],

    // other grid options ...
}
```

## Custom Distribution with a Callback

For full control over how group-level edits cascade, assign a function to `groupRowValueSetter`. The callback receives a `GroupRowValueSetterParams` object and should return `true` when any child value was changed.

The example below distributes the edited total equally among children, rounded to integers (largest remainder method). It calls `setDataValue` on each child; aggregation then refreshes parent totals automatically.

#### Custom Editable Group Totals

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  GroupRowValueSetterFunc,
  ModuleRegistry,
  NumberFilterModule,
  TextEditorModule,
  ValueParserParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  RowGroupingEditModule,
  RowGroupingModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

let gridApi: GridApi<SalesRecord>;

interface SalesRecord {
  id: string;
  region: string;
  segment: string;
  country: string;
  amount: number;
}

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberFilterModule,
  SetFilterModule,
  TextEditorModule,
]);

// Parse input to integer
const amountValueParser = (params: ValueParserParams): number | null => {
  const numericValue = Number(params.newValue);
  return Number.isFinite(numericValue)
    ? Math.round(numericValue)
    : (params.oldValue ?? null);
};

/**
 * Distributes a new group total equally among children.
 *
 * `aggregatedChildren` contains the immediate children used for aggregation:
 * - For leaf groups: the data rows
 * - For non-leaf groups: the child groups
 *
 * Calling `setDataValue` on a child group triggers `groupRowValueSetter` again,
 * enabling recursive cascade through the entire group hierarchy.
 */
const cascadeGroupTotal: GroupRowValueSetterFunc<SalesRecord> = ({
  column,
  newValue,
  eventSource,
  aggregatedChildren,
}) => {
  const total = Number(newValue);
  if (!Number.isFinite(total) || !aggregatedChildren.length) {
    return false;
  }

  // Distribute equally among children
  // https://en.wikipedia.org/wiki/Largest_remainder_method
  const count = aggregatedChildren.length;
  const base = Math.floor(total / count);
  let remainder = Math.round(total) - base * count;

  // Apply the distributed values
  let changed = false;
  for (const child of aggregatedChildren) {
    let value = base;
    if (remainder > 0) {
      value++;
      remainder--;
    }
    if (child.setDataValue(column, value, eventSource)) {
      changed = true;
    }
  }
  return changed;
};

const gridOptions: GridOptions<SalesRecord> = {
  columnDefs: [
    { field: "region", rowGroup: true, hide: true },
    {
      field: "segment",
      rowGroup: true,
      hide: true,
      filter: "agSetColumnFilter",
    },
    { field: "country", filter: "agSetColumnFilter" },
    {
      headerName: "Amount",
      field: "amount",
      aggFunc: "sum",
      editable: true,
      groupRowEditable: true,
      filter: "agNumberColumnFilter",
      valueParser: amountValueParser,
      groupRowValueSetter: cascadeGroupTotal,
    },
  ],
  autoGroupColumnDef: {
    minWidth: 260,
    cellRendererParams: {
      suppressCount: true,
    },
  },
  defaultColDef: {
    flex: 1,
    sortable: true,
    filter: true,
    resizable: true,
  },
  rowData: getData(),
  groupAggFiltering: true,
  groupDefaultExpanded: -1,
  animateRows: true,
  getRowId: ({ data }) => data.id,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Custom Editable Group Totals](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/group-editable-totals-custom/typescript/)

### GroupRowValueSetterParams

Properties available on the `GroupRowValueSetterParams&lt;TData = any, TValue = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |
| `column` | `Column` |  |  |  |
| `colDef` | `ColDef` |  |  |  |
| `oldValue` | `TValue \| null \| undefined` |  |  |  |
| `newValue` | `TValue \| null \| undefined` |  |  |  |
| `node` | `IRowNode` |  |  |  |
| `data` | `TData \| null \| undefined` |  |  |  |
| `eventSource` | `string \| undefined` |  |  |  |
| `valueChanged` | `boolean` |  |  |  |
| `aggregatedChildren` | `IRowNode[]` |  |  |  |

### Aggregated Children

The `groupRowValueSetter` callback receives an `aggregatedChildren` array: the immediate children that contribute to the [Aggregation](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/aggregation/) for the edited column. Cascading edits to these children avoids traversing the row hierarchy by hand.

What `aggregatedChildren` returns depends on the column and grid configuration:

- **Regular value columns**: the direct children used for aggregation. This respects `suppressAggFilteredOnly` and `groupAggFiltering`; when those cause aggregation to include all children rather than just filtered ones, `aggregatedChildren` follows suit.
- **Pivot columns on leaf groups**: only the children matching the column's pivot keys, since pivot aggregation groups rows by pivot key values.
- **Non-group rows**: an empty array.

The same children can be retrieved programmatically with `rowNode.getAggregatedChildren(colKey)`. To collect all descendant leaf rows instead of only the immediate children, pass `true` as the second argument: `rowNode.getAggregatedChildren(colKey, true)`.

See [Retrieving Aggregated Children](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/aggregation/#retrieving-aggregated-children) for more details.

### Cascading Edits

Key points for implementing cascading edits:

- Call `rowNode.setDataValue` on each child to write the new value down.
- When a child is itself a group with its own `groupRowValueSetter`, the cascade recurses further.
- Parent aggregates refresh automatically: child `data` changes re-run the column `aggFunc`, so editing a group total rebalances the children to match it.
- Aggregation is batched. All `setDataValue` calls within a single `groupRowValueSetter` invocation are processed before re-aggregation runs.

> **Note**
>
> The `aggregatedChildren` parameter and `rowNode.getAggregatedChildren()` method are only supported with the Client-Side Row Model. For other row models, `aggregatedChildren` is an empty array.

### Calling distributeGroupValue

The built-in distribution function `distributeGroupValue` is exported from `ag-grid-enterprise` and can be called directly inside a custom `groupRowValueSetter` callback. This is useful when custom logic is needed before or after the distribution:

```ts
import { distributeGroupValue } from 'ag-grid-enterprise';

colDef.groupRowValueSetter = (params) => {
    // Custom pre-processing
    const adjusted = Math.max(0, Number(params.newValue));
    return distributeGroupValue({ ...params, newValue: adjusted }, { distribution: 'percentage' });
};
```

You can also assign `distributeGroupValue` directly without a wrapper for default behaviour:

```ts
import { distributeGroupValue } from 'ag-grid-enterprise';

colDef.groupRowValueSetter = distributeGroupValue;
```

## Editing Pivot Columns

When using [Pivoting](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/pivoting/), the `groupRowValueSetter` also works with pivot result columns. The key difference is that `aggregatedChildren` returns only the children matching the column's pivot keys, not all children of the group.

The following example uses the built-in distribution in pivot mode. Setting `groupRowEditable` enables distribution automatically. Double-click any pivot cell to edit it; the edited value is distributed uniformly among the children matching that pivot column's keys.

#### Built-in Pivot Editing

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  PivotModule,
  RowGroupingEditModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { SalesRecord, getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
  PivotModule,
]);

let gridApi: GridApi<SalesRecord>;

const gridOptions: GridOptions<SalesRecord> = {
  columnDefs: [
    { field: "region", rowGroup: true, hide: true },
    { field: "country", rowGroup: true, hide: true },
    { field: "product", pivot: true },
    {
      headerName: "Amount",
      field: "amount",
      aggFunc: "sum",
      editable: true,

      // Enable editing on group rows. When groupRowEditable is defined, the
      // built-in distribution is used automatically — 'uniform' for 'sum',
      // dividing the new total equally among children matching the pivot keys.
      groupRowEditable: true,
    },
  ],
  autoGroupColumnDef: {
    minWidth: 200,
    cellRendererParams: { suppressCount: true },
  },
  defaultColDef: {
    flex: 1,
    minWidth: 120,
    sortable: true,
    filter: true,
    resizable: true,
  },
  pivotMode: true,
  rowData: getData(),
  groupDefaultExpanded: -1,
  getRowId: ({ data }) => data.id,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Built-in Pivot Editing](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/pivot-editable-builtin/typescript/)

For full control, use a custom `groupRowValueSetter` callback. In the example below:

- The grid is pivoted by `product` (Electronics, Clothing, Food), grouped by `region` and `country`.
- Double-clicking any pivot column cell opens the editor for the aggregated value.
- When editing a pivot cell (e.g. "Electronics" on the "Europe" row), `aggregatedChildren` contains only the European rows selling Electronics, not all European rows.
- The edit is distributed equally among those matching children, leaving other product categories unchanged.

#### Custom Editable Pivot Totals

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  GroupRowValueSetterFunc,
  ModuleRegistry,
  NumberFilterModule,
  TextEditorModule,
  ValueParserParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingEditModule,
  RowGroupingModule,
  SideBarModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

interface SalesRecord {
  id: string;
  region: string;
  country: string;
  product: string;
  amount: number;
}

let gridApi: GridApi<SalesRecord>;

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberFilterModule,
  TextEditorModule,
  PivotModule,
  SideBarModule,
  ColumnsToolPanelModule,
]);

// Parse input to integer
const amountValueParser = (params: ValueParserParams): number | null => {
  const numericValue = Number(params.newValue);
  return Number.isFinite(numericValue)
    ? Math.round(numericValue)
    : (params.oldValue ?? null);
};

/**
 * Distributes a new pivot total equally among children.
 *
 * In pivot mode, `aggregatedChildren` contains only rows matching the pivot keys.
 * For example, editing the "Electronics 2024" cell returns only rows where
 * product="Electronics" AND year=2024.
 *
 * `setDataValue` on leaf rows with pivot columns auto-resolves to the underlying
 * value column. On group rows, it triggers `groupRowValueSetter` for recursive cascade.
 */
const cascadeGroupTotal: GroupRowValueSetterFunc<SalesRecord> = ({
  column,
  newValue,
  eventSource,
  aggregatedChildren,
}) => {
  const total = Number(newValue);
  if (!Number.isFinite(total) || !aggregatedChildren.length) {
    return false;
  }

  // Distribute equally among children
  // https://en.wikipedia.org/wiki/Largest_remainder_method
  const count = aggregatedChildren.length;
  const base = Math.floor(total / count);
  let remainder = Math.round(total) - base * count;

  // Apply the distributed values
  let changed = false;
  for (const child of aggregatedChildren) {
    let value = base;
    if (remainder > 0) {
      value++;
      remainder--;
    }
    if (child.setDataValue(column, value, eventSource)) {
      changed = true;
    }
  }
  return changed;
};

const gridOptions: GridOptions<SalesRecord> = {
  columnDefs: [
    { field: "region", rowGroup: true, hide: true },
    { field: "country", rowGroup: true, hide: true },
    { field: "product", pivot: true },
    {
      headerName: "Amount",
      field: "amount",
      aggFunc: "sum",
      editable: true,
      groupRowEditable: true,
      valueParser: amountValueParser,
      groupRowValueSetter: cascadeGroupTotal,
    },
  ],
  autoGroupColumnDef: {
    minWidth: 200,
    cellRendererParams: {
      suppressCount: true,
    },
  },
  defaultColDef: {
    flex: 1,
    minWidth: 120,
    sortable: true,
    filter: true,
    resizable: true,
  },
  pivotMode: true,
  sideBar: "columns",
  rowData: getData(),
  groupDefaultExpanded: -1,
  getRowId: ({ data }) => data.id,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Custom Editable Pivot Totals](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/pivot-editable-totals-custom/typescript/)

Edits on pivot columns therefore affect only the rows contributing to that pivot value, leaving other pivot categories untouched.

## Tree Data

`groupRowEditable` and `groupRowValueSetter` also work with [Tree Data](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tree-data/). Parent nodes act as group rows, so editing a parent's aggregated value cascades the change down to its children just as with row grouping.

The example below shows a company's budget organised as a tree: departments contain teams, and teams contain employees. Editing a department's or team's budget distributes the new total equally among its members, rounded to integers, recursing through the hierarchy.

#### Tree Data Editable

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingEditModule, TreeDataModule } from "ag-grid-enterprise";
import { BudgetRecord, getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  TreeDataModule,
  RowGroupingEditModule,
  NumberEditorModule,
]);

let gridApi: GridApi<BudgetRecord>;

const gridOptions: GridOptions<BudgetRecord> = {
  columnDefs: [
    {
      headerName: "Budget",
      field: "budget",
      aggFunc: "sum",
      editable: true,

      // Enable editing on group (department/team) rows.
      // The built-in distribution divides the new budget equally among
      // children, cascading through the full tree hierarchy.
      groupRowEditable: true,
      groupRowValueSetter: { precision: 0 },
    },
  ],
  defaultColDef: {
    flex: 1,
  },
  autoGroupColumnDef: {
    headerName: "Department / Team / Employee",
    field: "name",
    minWidth: 280,
    cellRendererParams: { suppressCount: true },
  },
  treeData: true,
  treeDataChildrenField: "children",
  groupDefaultExpanded: -1,
  getRowId: ({ data }) => data.name,
  rowData: getData(),
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Tree Data Editable](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/tree-data-editable/typescript/)

## Refreshing Groups After Editing

When grouped columns are editable, setting `refreshAfterGroupEdit=true` causes the grid to update row data and recalculate the grouping after every committed edit. Without this option, the row data updates but the grouping does not get updated until the next full refresh.

When enabling `refreshAfterGroupEdit`, also provide `getRowId` so that the grid can track rows by stable IDs while rebuilding the grouping hierarchy.

The following example demonstrates this behaviour. Double-click on a `department` or `team` cell to edit it; the grid re-evaluates the grouping and moves the row to the correct group instantly.

#### Refresh After Group Edit

```ts
import {
  ClientSideRowModelModule,
  GridOptions,
  ModuleRegistry,
  SelectEditorModule,
  TextEditorModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";

interface Employee {
  id: string;
  department: string;
  team: string;
  name: string;
  role: string;
}

const departments = ["Engineering", "Sales", "Marketing"];
const teams: Record<string, string[]> = {
  Engineering: ["Frontend", "Backend", "QA"],
  Sales: ["Enterprise", "SMB", "Partners"],
  Marketing: ["Content", "Growth", "Brand"],
};
const allTeams = Object.values(teams).flat();

function getData(): Employee[] {
  return [
    // Engineering
    {
      id: "1",
      department: "Engineering",
      team: "Frontend",
      name: "Alice",
      role: "Developer",
    },
    {
      id: "2",
      department: "Engineering",
      team: "Frontend",
      name: "Bob",
      role: "Developer",
    },
    {
      id: "3",
      department: "Engineering",
      team: "Backend",
      name: "Carol",
      role: "Developer",
    },
    {
      id: "4",
      department: "Engineering",
      team: "Backend",
      name: "Dave",
      role: "Tech Lead",
    },
    {
      id: "5",
      department: "Engineering",
      team: "QA",
      name: "Eve",
      role: "Tester",
    },

    // Sales
    {
      id: "6",
      department: "Sales",
      team: "Enterprise",
      name: "Frank",
      role: "Account Exec",
    },
    {
      id: "7",
      department: "Sales",
      team: "Enterprise",
      name: "Grace",
      role: "Account Exec",
    },
    {
      id: "8",
      department: "Sales",
      team: "SMB",
      name: "Hank",
      role: "Sales Rep",
    },
    {
      id: "9",
      department: "Sales",
      team: "Partners",
      name: "Ivy",
      role: "Partner Manager",
    },

    // Marketing
    {
      id: "10",
      department: "Marketing",
      team: "Content",
      name: "Jack",
      role: "Writer",
    },
    {
      id: "11",
      department: "Marketing",
      team: "Growth",
      name: "Kim",
      role: "Analyst",
    },
    {
      id: "12",
      department: "Marketing",
      team: "Brand",
      name: "Leo",
      role: "Designer",
    },
  ];
}

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  ClientSideRowModelModule,
  TextEditorModule,
  TextFilterModule,
  SelectEditorModule,
]);

const gridOptions: GridOptions<Employee> = {
  columnDefs: [
    {
      field: "department",
      rowGroup: true,
      editable: true,
      cellEditor: "agSelectCellEditor",
      cellEditorParams: { values: departments },
    },
    {
      field: "team",
      rowGroup: true,
      editable: true,
      cellEditor: "agSelectCellEditor",
      cellEditorParams: { values: allTeams },
    },
    { field: "name" },
    { field: "role", editable: true },
  ],
  defaultColDef: {
    flex: 1,
    sortable: true,
    resizable: true,
    filter: true,
  },
  autoGroupColumnDef: {
    minWidth: 250,
  },
  rowData: getData(),
  refreshAfterGroupEdit: true,
  groupDefaultExpanded: -1,
  animateRows: true,
  getRowId: ({ data }) => data.id,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
createGrid(gridDiv, gridOptions);
```

[Live example: Refresh After Group Edit](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/refresh-after-group-edit/typescript/)

See also [Read Only Edit](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/value-setters/#read-only-edit) for configuring immutable grouped data or connecting the grid with a store.


---
product: "AG Grid"
title: "Row Grouping - Editing Groups"
description: "The grid supports editing grouped data when using the . This page covers making group row cells editable, distributing edited values to descendant rows, and refreshing the grouping hierarchy after edits."
enterprise: true
framework: vue
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping/"
    - title: "Grouping Data"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-data/"
    - title: "Group Display Types"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-display-types/"
    - title: "Row Group Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-group-panel/"
    - title: "Expanding Groups"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-opening-groups/"
    - title: "Hierarchy Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-row-selection/"
    - title: "Sorting"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-sorting/"
    - title: "Row Dragging"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-row-dragging/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Row Grouping - Editing Groups

The grid supports editing grouped data when using the [Client-Side Row Model](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-models/#client-side). This page covers making group row cells editable, distributing edited values to descendant rows, and refreshing the grouping hierarchy after edits.

## Editing Group Row Cells

Set `groupRowEditable` on any column to make its group row cells editable. The grid then distributes the edited value to descendant rows using the built-in distribution. To customise this, set `groupRowValueSetter` to an options object, a callback, or `false` to disable distribution.

In the example below, double-click any group row's `Sales` cell to edit it. The new total spreads equally across the group's children, recursing through nested groups.

#### Built-in Sum Distribution

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingEditModule, RowGroupingModule } from "ag-grid-enterprise";
import { SalesRecord } from "./data";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      class="ag-theme-quartz"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :autoGroupColumnDef="autoGroupColumnDef"
      :defaultColDef="defaultColDef"
      :rowData="rowData"
      :groupDefaultExpanded="groupDefaultExpanded"
      :getRowId="getRowId"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<SalesRecord> | null>(null);
    const columnDefs = ref<(ColDef | ColGroupDef)[]>([
      { field: "region", rowGroup: true, hide: true },
      { field: "country", rowGroup: true, hide: true },
      {
        headerName: "Sales",
        field: "sales",
        aggFunc: "sum",
        editable: true,
        // Enable editing on group rows and use the built-in distribution.
        // With 'sum' aggregation, the default strategy is 'uniform' — the new total
        // is divided equally among all children.
        // precision: 0 rounds values to integers and spreads the rounding remainder
        // across children so the total matches exactly.
        groupRowEditable: true,
        groupRowValueSetter: {
          precision: 0,
        },
      },
    ]);
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 220,
      cellRendererParams: { suppressCount: true },
    });
    const defaultColDef = ref<ColDef>({
      flex: 1,
      sortable: true,
      filter: true,
      resizable: true,
    });
    const rowData = ref<SalesRecord[] | null>(getData());
    const groupDefaultExpanded = ref(-1);
    const getRowId = ref<GetRowIdFunc>(({ data }) => data.id);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      autoGroupColumnDef,
      defaultColDef,
      rowData,
      groupDefaultExpanded,
      getRowId,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Built-in Sum Distribution](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/distribute-group-value-sum/vue3/)

`groupRowEditable` accepts a `boolean` or a callback. The callback runs only for group rows (`rowNode.group === true`); leaf rows continue to honour `editable`. When a column sets both properties, the grid uses whichever matches the current row type, allowing separate rules for group rows and leaf rows.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `groupRowEditable` | `boolean \| GroupRowEditableCallback` |  |  |  |
| `groupRowValueSetter` | `boolean \| GroupRowValueSetterFunc \| GroupRowValueSetterOptions` |  |  |  |

## Built-in Value Distribution

The built-in distribution adjusts each child so the column's `aggFunc` produces the new total. Pass an options object to `groupRowValueSetter` to customise the strategy or precision.

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: 'sales',
        aggFunc: 'sum',
        editable: true,
        groupRowEditable: true,
        // Built-in distribution: divides the sum equally among children.
        // precision: 0 rounds child values to integers and spreads the remainder.
        groupRowValueSetter: { precision: 0 },
    },
];
```

### Distribution Strategies

The `distribution` option controls how the edited value is spread across children. When omitted, the strategy is chosen automatically based on the column's `aggFunc`:

| Strategy | Behaviour | Default for |
| --- | --- | --- |
| `'uniform'` | Divides the new value equally among all children. | `sum` |
| `'overwrite'` | Writes the new value directly to every child. | `avg`, no aggFunc |
| `'percentage'` | Scales each child proportionally, preserving relative weights. Falls back to `'uniform'` when the current total is zero. | — |
| `'increment'` | Distributes only the difference (`newValue − oldValue`) among children, adding it to current values. | — |

Editing is **disabled by default** for `count`, `min`, `max`, `first`, `last`, and **custom aggregation functions**. These functions have no unique inverse, so the grid cannot choose a safe default. To enable editing for them:

- Set `distribution` to `'overwrite'` to write the new value directly to every child.
- Provide a per-aggFunc record entry with `'overwrite'`, `true`, or a custom callback (see [Per-Aggregation Strategies](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-edit/#per-aggregation-strategies)).
- Assign a [callback](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-edit/#custom-distribution-with-a-callback) to `groupRowValueSetter` for full control.

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: 'price',
        aggFunc: 'min',
        editable: true,
        groupRowEditable: true,
        // 'overwrite' writes the edited value to every child
        groupRowValueSetter: { distribution: 'overwrite' },
    },
    {
        field: 'quantity',
        aggFunc: 'count',
        editable: true,
        groupRowEditable: true,
        // Per-aggFunc record: enable only count with overwrite
        groupRowValueSetter: { distribution: { count: 'overwrite' } },
    },
];
```

Setting `distribution` to `true` uses built-in defaults for `sum`, `avg`, no-aggFunc columns, and custom aggregation functions. The `count`, `min`, `max`, `first`, and `last` functions stay disabled even with `true`; use `'overwrite'`, a per-aggFunc record entry, or a callback to enable them.

Setting `distribution` to `false` or `null` suppresses distribution and makes the cell not editable, even when `groupRowEditable` is `true`.

For `avg`, every strategy adjusts child values so the children's average equals the edited value.

> **Note**
>
> The `precision` option rounds the values written to **child rows**, not the group row's displayed value. The group value is re-computed by the column's `aggFunc` from the rounded children. For `sum` this is always exact. For `avg` the re-aggregated value may differ: distributing `precision: 0` across 3 children produces integers, but their average (`10 / 3 ≈ 3.33`) is not. Use a [Value Formatter](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/value-formatters/) to control how the group row displays the re-aggregated value.

### Distribution Options

Properties available on the `GroupRowValueSetterOptions&lt;TData = any, TValue = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `distribution` | `Distribution` |  |  |  |
| `default` | `GroupRowValueSetterDistributionEntry` |  |  |  |
| `precision` | `number \| false` |  |  |  |
| `getValue` | `Function` |  |  |  |
| `setValue` | `Function` |  |  |  |

### Merging with Default Column Definitions

When `groupRowValueSetter` is set as an options object on both `defaultColDef` and a column, the grid deep merges the two. The column's properties take precedence; anything not specified on the column is inherited from the default. This includes nested `distribution` records.

```ts
<ag-grid-vue
    :defaultColDef="defaultColDef"
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.defaultColDef = {
    editable: true,
    groupRowEditable: true,
    // Default: round child values to integers, disable count
    groupRowValueSetter: { precision: 0, distribution: { count: false } },
};
this.columnDefs = [
    {
        field: 'sales',
        aggFunc: 'sum',
        // Column-level override: use percentage distribution.
        // precision: 0 is inherited from defaultColDef.
        groupRowValueSetter: { distribution: 'percentage' },
    },
    {
        field: 'quantity',
        aggFunc: 'count',
        // Override defaultColDef's false with true to enable editing for count.
        groupRowValueSetter: { distribution: { count: true } },
    },
    {
        field: 'profit',
        aggFunc: 'sum',
        // No column-level override — inherits { precision: 0 } from defaultColDef.
    },
];
```

> **Note**
>
> Deep merging only applies when both the `defaultColDef` and the column define `groupRowValueSetter` as plain objects. If the column defines a callback function, it replaces the default entirely.

### Multiple Aggregation Functions

The following example mixes built-in strategies, a non-aggregated column, and custom callbacks. Double-click any group row cell to edit it:

- **Salary** (`sum`): divides the new total equally among children, rounded to integers (`precision: 0`). Editing 300 across 3 children produces 100 each.
- **Bonus** (`avg`): overwrites every child with the edited value. Editing the average to 15 sets all children's bonus to 15.
- **Projects** (no `aggFunc`): overwrites every child with the edited value. The group cell is blank but still editable.
- **Rate %** (custom callback): computes each leaf child's bonus as `salary × rate / 100`. Entering 20 sets each child's bonus to 20% of their salary. Uses `node.getAggregatedChildren(column, true)` to reach all descendant leaf rows directly.
- **SumSq** (custom `sumOfSquares` aggFunc): a callback sets each child to `√(newValue / count)`, the inverse of sum-of-squares.

#### Multiple Aggregation Functions

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GroupRowValueSetterFunc,
  IAggFunc,
  IAggFuncParams,
  IAggFuncs,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingEditModule, RowGroupingModule } from "ag-grid-enterprise";
import { MetricsRecord } from "./data";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  TextFilterModule,
]);

/** Custom aggregation function: sum of squares. */
const sumOfSquares: IAggFunc = (params: IAggFuncParams) => {
  let total = 0;
  for (const value of params.values) {
    const n = Number(value);
    if (Number.isFinite(n)) {
      total += n * n;
    }
  }
  return total;
};

/**
 * Custom groupRowValueSetter for sumOfSquares.
 *
 * Because sumOfSquares uses x² in its aggregation, the built-in strategies
 * (uniform, percentage, etc.) would not produce correct results.
 * Instead, we compute the square root to find the per-child value that
 * produces the desired aggregate: each child = √(newValue / count).
 */
const sumOfSquaresValueSetter: GroupRowValueSetterFunc<MetricsRecord> = ({
  newValue,
  aggregatedChildren,
  column,
}) => {
  const target = Number(newValue);
  const count = aggregatedChildren.length;
  if (!count || !Number.isFinite(target)) {
    return false;
  }
  const perChild = Math.round(Math.sqrt(Math.max(0, target / count)));
  let changed = false;
  for (const child of aggregatedChildren) {
    if (child.setDataValue(column, perChild, "data")) {
      changed = true;
    }
  }
  return changed;
};

/**
 * Cross-column groupRowValueSetter: editing the group row's "Rate %"
 * sets each leaf child's bonus to a percentage of their individual salary.
 *
 * Uses getAggregatedChildren with recursive=true to reach all descendant
 * leaf rows, since intermediate group rows don't have salary data.
 *
 * For example, entering 20 on the Engineering group sets each engineer's
 * bonus to 20% of their salary: Alice (salary 90) gets bonus 18,
 * Dave (salary 95) gets bonus 19, etc.
 */
const bonusRateSetter: GroupRowValueSetterFunc<MetricsRecord> = ({
  newValue,
  node,
  column,
}) => {
  const rate = Number(newValue) / 100;
  if (!Number.isFinite(rate)) {
    return false;
  }
  const leaves = node.getAggregatedChildren(column, true);
  if (!leaves.length) {
    return false;
  }
  let changed = false;
  for (const child of leaves) {
    const salary = child.data?.salary ?? 0;
    if (child.setDataValue("bonus", Math.round(salary * rate), "data")) {
      changed = true;
    }
  }
  return changed;
};

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      class="ag-theme-quartz"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :aggFuncs="aggFuncs"
      :autoGroupColumnDef="autoGroupColumnDef"
      :rowData="rowData"
      :groupDefaultExpanded="groupDefaultExpanded"
      :getRowId="getRowId"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<MetricsRecord> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "department", rowGroup: true, hide: true },
      { field: "team", rowGroup: true, hide: true },
      { field: "employee", minWidth: 120 },
      // sum: uniform distribution (divides equally), with integer rounding
      {
        field: "salary",
        aggFunc: "sum",
        groupRowValueSetter: { precision: 0 },
      },
      // avg: default strategy is 'overwrite' — sets every child to the edited value
      {
        field: "bonus",
        aggFunc: "avg",
        valueFormatter: ({ value }) =>
          value != null ? Number(value).toFixed(2) : "",
      },
      // No aggFunc: the default strategy is 'overwrite', writing the edited
      // value to every child. The group cell is blank (no aggregation) but
      // still editable via groupRowEditable.
      { field: "projects" },
      // Cross-column custom callback: editing the group row's "Rate"
      // reads each child's salary and writes a computed bonus.
      {
        headerName: "Rate %",
        valueGetter: ({ data }) =>
          data ? (data.bonus / data.salary) * 100 : null,
        valueFormatter: ({ value }) =>
          value != null ? Number(value).toFixed(2) : "",
        aggFunc: "avg",
        editable: false,
        groupRowEditable: true,
        groupRowValueSetter: bonusRateSetter,
      },
      // Custom aggregation function with a custom groupRowValueSetter
      {
        headerName: "SumSq",
        field: "score",
        aggFunc: "sumOfSquares",
        groupRowValueSetter: sumOfSquaresValueSetter,
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 120,
      sortable: true,
      filter: true,
      resizable: true,
      // Enable editing on all columns (leaf rows and group rows).
      // When groupRowEditable is defined, the built-in distribution
      // automatically uses the right strategy for each aggregation function.
      editable: true,
      groupRowEditable: true,
    });
    const aggFuncs = ref<IAggFuncs>({
      sumOfSquares,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
      cellRendererParams: { suppressCount: true },
    });
    const rowData = ref<MetricsRecord[] | null>(getData());
    const groupDefaultExpanded = ref(-1);
    const getRowId = ref<GetRowIdFunc>(({ data }) => data.id);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      aggFuncs,
      autoGroupColumnDef,
      rowData,
      groupDefaultExpanded,
      getRowId,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Multiple Aggregation Functions](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/distribute-group-value-all-agg/vue3/)

### Per-Aggregation Strategies

When several columns share a `groupRowValueSetter` (e.g. via `defaultColDef`) but use different aggregation functions, set `distribution` to a record keyed by `aggFunc` name. Each entry can be a strategy string, an options object, a custom callback, `true` for built-in defaults, or `false`/`null` to suppress distribution for that aggFunc:

```ts
<ag-grid-vue
    :aggFuncs="aggFuncs"
    :defaultColDef="defaultColDef"
    /* other grid options ... */>
</ag-grid-vue>

const myCustomAgg = (params) => {
    let total = 0;
    for (const value of params.values) {
        total += Number(value) || 0;
    }
    return total;
};

// Optional: inverse enables incremental aggregation on row changes
myCustomAgg.inverse = (params) => {
    let total = Number(params.result) || 0;
    for (const value of params.values) {
        total -= Number(value) || 0;
    }
    return total;
};

this.aggFuncs = {
    myCustomAgg,
};
this.defaultColDef = {
    editable: true,
    groupRowEditable: true,
    groupRowValueSetter: {
        precision: 0,
        distribution: {
            sum: 'percentage',                          // strategy string
            avg: { distribution: 'increment' },         // options object
            myCustomAgg: (params) => {                  // custom callback function
                for (const child of params.aggregatedChildren) {
                    child.setDataValue(params.column, params.newValue, 'data');
                }
                return true;
            },
        },
    },
};
```

Custom aggregation functions are disabled by default. To enable editing, add an explicit entry in the `distribution` record. The entry can be a strategy string, an options object, or a callback that implements the inverse of the aggregation logic:

```ts
<ag-grid-vue
    :defaultColDef="defaultColDef"
    /* other grid options ... */>
</ag-grid-vue>

this.defaultColDef = {
    editable: true,
    groupRowEditable: true,
    groupRowValueSetter: {
        precision: 0,
        distribution: {
            sum: 'percentage',
            avg: 'increment',
            count: 'overwrite',
            // Custom aggFunc: provide a callback that reverses the aggregation
            myCustomAgg: (params) => {
                for (const child of params.aggregatedChildren) {
                    child.setDataValue(params.column, params.newValue, 'data');
                }
                return true;
            },
        },
    },
};
```

Aggregation functions not listed in the record fall through to the `default` fallback, then to the built-in defaults (see the strategy table above).

### Default Fallback

When multiple custom aggregation functions share the same distribution logic, the `default` property avoids repeating entries for each one. It applies to any aggregation function not explicitly listed in the `distribution` record, including custom aggregations (which are otherwise disabled) and columns with no `aggFunc` (which already default to `'overwrite'`). Non-distributable functions (`count`, `min`, `max`, `first`, `last`) are **not** affected by `default` and must always be listed explicitly.

```ts
<ag-grid-vue
    :defaultColDef="defaultColDef"
    /* other grid options ... */>
</ag-grid-vue>

this.defaultColDef = {
    editable: true,
    groupRowEditable: true,
    groupRowValueSetter: {
        precision: 0,
        distribution: {
            sum: 'percentage',
            count: 'overwrite',
        },
        // Fallback for unlisted custom aggFuncs and no-aggFunc columns.
        default: 'overwrite',
    },
};
```

### Custom getValue and setValue

The `getValue` and `setValue` callbacks override how the built-in distributor reads from and writes to child rows. By default it uses `node.getDataValue(column, 'value')` to read and `node.setDataValue(column, value, 'data')` to write. Provide your own when child values live on a different field or custom data structure, when you need to apply transformations or side effects during distribution, or when the column's `valueGetter` / `valueSetter` are not suitable for distribution.

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: 'amount',
        aggFunc: 'sum',
        editable: true,
        groupRowEditable: true,
        groupRowValueSetter: {
            distribution: 'percentage',
            getValue: (params) => (params.data && params.data.weight) || 0,
            setValue: (params) => params.node.setDataValue(params.column, params.value, 'data'),
        },
    },
];
```

## Custom Distribution with a Callback

For full control over how group-level edits cascade, assign a function to `groupRowValueSetter`. The callback receives a `GroupRowValueSetterParams` object and should return `true` when any child value was changed.

The example below distributes the edited total equally among children, rounded to integers (largest remainder method). It calls `setDataValue` on each child; aggregation then refreshes parent totals automatically.

#### Custom Editable Group Totals

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GroupRowValueSetterFunc,
  IsRowFilterable,
  ModuleRegistry,
  NumberFilterModule,
  TextEditorModule,
  ValueParserParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  RowGroupingEditModule,
  RowGroupingModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberFilterModule,
  SetFilterModule,
  TextEditorModule,
]);

interface SalesRecord {
  id: string;
  region: string;
  segment: string;
  country: string;
  amount: number;
}

// Parse input to integer
const amountValueParser = (params: ValueParserParams): number | null => {
  const numericValue = Number(params.newValue);
  return Number.isFinite(numericValue)
    ? Math.round(numericValue)
    : (params.oldValue ?? null);
};

/**
 * Distributes a new group total equally among children.
 *
 * `aggregatedChildren` contains the immediate children used for aggregation:
 * - For leaf groups: the data rows
 * - For non-leaf groups: the child groups
 *
 * Calling `setDataValue` on a child group triggers `groupRowValueSetter` again,
 * enabling recursive cascade through the entire group hierarchy.
 */
const cascadeGroupTotal: GroupRowValueSetterFunc<SalesRecord> = ({
  column,
  newValue,
  eventSource,
  aggregatedChildren,
}) => {
  const total = Number(newValue);
  if (!Number.isFinite(total) || !aggregatedChildren.length) {
    return false;
  }
  // Distribute equally among children
  // https://en.wikipedia.org/wiki/Largest_remainder_method
  const count = aggregatedChildren.length;
  const base = Math.floor(total / count);
  let remainder = Math.round(total) - base * count;
  // Apply the distributed values
  let changed = false;
  for (const child of aggregatedChildren) {
    let value = base;
    if (remainder > 0) {
      value++;
      remainder--;
    }
    if (child.setDataValue(column, value, eventSource)) {
      changed = true;
    }
  }
  return changed;
};

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      class="ag-theme-quartz"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :autoGroupColumnDef="autoGroupColumnDef"
      :defaultColDef="defaultColDef"
      :rowData="rowData"
      :groupAggFiltering="true"
      :groupDefaultExpanded="groupDefaultExpanded"
      :animateRows="true"
      :getRowId="getRowId"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<SalesRecord> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "region", rowGroup: true, hide: true },
      {
        field: "segment",
        rowGroup: true,
        hide: true,
        filter: "agSetColumnFilter",
      },
      { field: "country", filter: "agSetColumnFilter" },
      {
        headerName: "Amount",
        field: "amount",
        aggFunc: "sum",
        editable: true,
        groupRowEditable: true,
        filter: "agNumberColumnFilter",
        valueParser: amountValueParser,
        groupRowValueSetter: cascadeGroupTotal,
      },
    ]);
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 260,
      cellRendererParams: {
        suppressCount: true,
      },
    });
    const defaultColDef = ref<ColDef>({
      flex: 1,
      sortable: true,
      filter: true,
      resizable: true,
    });
    const rowData = ref<SalesRecord[] | null>(getData());
    const groupDefaultExpanded = ref(-1);
    const getRowId = ref<GetRowIdFunc>(({ data }) => data.id);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      autoGroupColumnDef,
      defaultColDef,
      rowData,
      groupDefaultExpanded,
      getRowId,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Custom Editable Group Totals](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/group-editable-totals-custom/vue3/)

### GroupRowValueSetterParams

Properties available on the `GroupRowValueSetterParams&lt;TData = any, TValue = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |
| `column` | `Column` |  |  |  |
| `colDef` | `ColDef` |  |  |  |
| `oldValue` | `TValue \| null \| undefined` |  |  |  |
| `newValue` | `TValue \| null \| undefined` |  |  |  |
| `node` | `IRowNode` |  |  |  |
| `data` | `TData \| null \| undefined` |  |  |  |
| `eventSource` | `string \| undefined` |  |  |  |
| `valueChanged` | `boolean` |  |  |  |
| `aggregatedChildren` | `IRowNode[]` |  |  |  |

### Aggregated Children

The `groupRowValueSetter` callback receives an `aggregatedChildren` array: the immediate children that contribute to the [Aggregation](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/aggregation/) for the edited column. Cascading edits to these children avoids traversing the row hierarchy by hand.

What `aggregatedChildren` returns depends on the column and grid configuration:

- **Regular value columns**: the direct children used for aggregation. This respects `suppressAggFilteredOnly` and `groupAggFiltering`; when those cause aggregation to include all children rather than just filtered ones, `aggregatedChildren` follows suit.
- **Pivot columns on leaf groups**: only the children matching the column's pivot keys, since pivot aggregation groups rows by pivot key values.
- **Non-group rows**: an empty array.

The same children can be retrieved programmatically with `rowNode.getAggregatedChildren(colKey)`. To collect all descendant leaf rows instead of only the immediate children, pass `true` as the second argument: `rowNode.getAggregatedChildren(colKey, true)`.

See [Retrieving Aggregated Children](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/aggregation/#retrieving-aggregated-children) for more details.

### Cascading Edits

Key points for implementing cascading edits:

- Call `rowNode.setDataValue` on each child to write the new value down.
- When a child is itself a group with its own `groupRowValueSetter`, the cascade recurses further.
- Parent aggregates refresh automatically: child `data` changes re-run the column `aggFunc`, so editing a group total rebalances the children to match it.
- Aggregation is batched. All `setDataValue` calls within a single `groupRowValueSetter` invocation are processed before re-aggregation runs.

> **Note**
>
> The `aggregatedChildren` parameter and `rowNode.getAggregatedChildren()` method are only supported with the Client-Side Row Model. For other row models, `aggregatedChildren` is an empty array.

### Calling distributeGroupValue

The built-in distribution function `distributeGroupValue` is exported from `ag-grid-enterprise` and can be called directly inside a custom `groupRowValueSetter` callback. This is useful when custom logic is needed before or after the distribution:

```ts
import { distributeGroupValue } from 'ag-grid-enterprise';

colDef.groupRowValueSetter = (params) => {
    // Custom pre-processing
    const adjusted = Math.max(0, Number(params.newValue));
    return distributeGroupValue({ ...params, newValue: adjusted }, { distribution: 'percentage' });
};
```

You can also assign `distributeGroupValue` directly without a wrapper for default behaviour:

```ts
import { distributeGroupValue } from 'ag-grid-enterprise';

colDef.groupRowValueSetter = distributeGroupValue;
```

## Editing Pivot Columns

When using [Pivoting](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/pivoting/), the `groupRowValueSetter` also works with pivot result columns. The key difference is that `aggregatedChildren` returns only the children matching the column's pivot keys, not all children of the group.

The following example uses the built-in distribution in pivot mode. Setting `groupRowEditable` enables distribution automatically. Double-click any pivot cell to edit it; the edited value is distributed uniformly among the children matching that pivot column's keys.

#### Built-in Pivot Editing

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  PivotModule,
  RowGroupingEditModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { SalesRecord } from "./data";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
  PivotModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      class="ag-theme-quartz"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :autoGroupColumnDef="autoGroupColumnDef"
      :defaultColDef="defaultColDef"
      :pivotMode="true"
      :rowData="rowData"
      :groupDefaultExpanded="groupDefaultExpanded"
      :getRowId="getRowId"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<SalesRecord> | null>(null);
    const columnDefs = ref<(ColDef | ColGroupDef)[]>([
      { field: "region", rowGroup: true, hide: true },
      { field: "country", rowGroup: true, hide: true },
      { field: "product", pivot: true },
      {
        headerName: "Amount",
        field: "amount",
        aggFunc: "sum",
        editable: true,
        // Enable editing on group rows. When groupRowEditable is defined, the
        // built-in distribution is used automatically — 'uniform' for 'sum',
        // dividing the new total equally among children matching the pivot keys.
        groupRowEditable: true,
      },
    ]);
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
      cellRendererParams: { suppressCount: true },
    });
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 120,
      sortable: true,
      filter: true,
      resizable: true,
    });
    const rowData = ref<SalesRecord[] | null>(getData());
    const groupDefaultExpanded = ref(-1);
    const getRowId = ref<GetRowIdFunc>(({ data }) => data.id);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      autoGroupColumnDef,
      defaultColDef,
      rowData,
      groupDefaultExpanded,
      getRowId,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Built-in Pivot Editing](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/pivot-editable-builtin/vue3/)

For full control, use a custom `groupRowValueSetter` callback. In the example below:

- The grid is pivoted by `product` (Electronics, Clothing, Food), grouped by `region` and `country`.
- Double-clicking any pivot column cell opens the editor for the aggregated value.
- When editing a pivot cell (e.g. "Electronics" on the "Europe" row), `aggregatedChildren` contains only the European rows selling Electronics, not all European rows.
- The edit is distributed equally among those matching children, leaving other product categories unchanged.

#### Custom Editable Pivot Totals

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GroupRowValueSetterFunc,
  ModuleRegistry,
  NumberFilterModule,
  SideBarDef,
  TextEditorModule,
  ValueParserParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingEditModule,
  RowGroupingModule,
  SideBarModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberFilterModule,
  TextEditorModule,
  PivotModule,
  SideBarModule,
  ColumnsToolPanelModule,
]);

interface SalesRecord {
  id: string;
  region: string;
  country: string;
  product: string;
  amount: number;
}

// Parse input to integer
const amountValueParser = (params: ValueParserParams): number | null => {
  const numericValue = Number(params.newValue);
  return Number.isFinite(numericValue)
    ? Math.round(numericValue)
    : (params.oldValue ?? null);
};

/**
 * Distributes a new pivot total equally among children.
 *
 * In pivot mode, `aggregatedChildren` contains only rows matching the pivot keys.
 * For example, editing the "Electronics 2024" cell returns only rows where
 * product="Electronics" AND year=2024.
 *
 * `setDataValue` on leaf rows with pivot columns auto-resolves to the underlying
 * value column. On group rows, it triggers `groupRowValueSetter` for recursive cascade.
 */
const cascadeGroupTotal: GroupRowValueSetterFunc<SalesRecord> = ({
  column,
  newValue,
  eventSource,
  aggregatedChildren,
}) => {
  const total = Number(newValue);
  if (!Number.isFinite(total) || !aggregatedChildren.length) {
    return false;
  }
  // Distribute equally among children
  // https://en.wikipedia.org/wiki/Largest_remainder_method
  const count = aggregatedChildren.length;
  const base = Math.floor(total / count);
  let remainder = Math.round(total) - base * count;
  // Apply the distributed values
  let changed = false;
  for (const child of aggregatedChildren) {
    let value = base;
    if (remainder > 0) {
      value++;
      remainder--;
    }
    if (child.setDataValue(column, value, eventSource)) {
      changed = true;
    }
  }
  return changed;
};

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      class="ag-theme-quartz"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :autoGroupColumnDef="autoGroupColumnDef"
      :defaultColDef="defaultColDef"
      :pivotMode="true"
      :sideBar="sideBar"
      :rowData="rowData"
      :groupDefaultExpanded="groupDefaultExpanded"
      :getRowId="getRowId"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<SalesRecord> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "region", rowGroup: true, hide: true },
      { field: "country", rowGroup: true, hide: true },
      { field: "product", pivot: true },
      {
        headerName: "Amount",
        field: "amount",
        aggFunc: "sum",
        editable: true,
        groupRowEditable: true,
        valueParser: amountValueParser,
        groupRowValueSetter: cascadeGroupTotal,
      },
    ]);
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
      cellRendererParams: {
        suppressCount: true,
      },
    });
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 120,
      sortable: true,
      filter: true,
      resizable: true,
    });
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>(
      "columns",
    );
    const rowData = ref<SalesRecord[] | null>(getData());
    const groupDefaultExpanded = ref(-1);
    const getRowId = ref<GetRowIdFunc>(({ data }) => data.id);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      autoGroupColumnDef,
      defaultColDef,
      sideBar,
      rowData,
      groupDefaultExpanded,
      getRowId,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Custom Editable Pivot Totals](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/pivot-editable-totals-custom/vue3/)

Edits on pivot columns therefore affect only the rows contributing to that pivot value, leaving other pivot categories untouched.

## Tree Data

`groupRowEditable` and `groupRowValueSetter` also work with [Tree Data](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tree-data/). Parent nodes act as group rows, so editing a parent's aggregated value cascades the change down to its children just as with row grouping.

The example below shows a company's budget organised as a tree: departments contain teams, and teams contain employees. Editing a department's or team's budget distributes the new total equally among its members, rounded to integers, recursing through the hierarchy.

#### Tree Data Editable

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingEditModule, TreeDataModule } from "ag-grid-enterprise";
import { BudgetRecord } from "./data";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  TreeDataModule,
  RowGroupingEditModule,
  NumberEditorModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      class="ag-theme-quartz"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :autoGroupColumnDef="autoGroupColumnDef"
      :treeData="true"
      :treeDataChildrenField="treeDataChildrenField"
      :groupDefaultExpanded="groupDefaultExpanded"
      :getRowId="getRowId"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<BudgetRecord> | null>(null);
    const columnDefs = ref<(ColDef | ColGroupDef)[]>([
      {
        headerName: "Budget",
        field: "budget",
        aggFunc: "sum",
        editable: true,
        // Enable editing on group (department/team) rows.
        // The built-in distribution divides the new budget equally among
        // children, cascading through the full tree hierarchy.
        groupRowEditable: true,
        groupRowValueSetter: { precision: 0 },
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      headerName: "Department / Team / Employee",
      field: "name",
      minWidth: 280,
      cellRendererParams: { suppressCount: true },
    });
    const treeDataChildrenField = ref("children");
    const groupDefaultExpanded = ref(-1);
    const getRowId = ref<GetRowIdFunc>(({ data }) => data.name);
    const rowData = ref<BudgetRecord[] | null>(getData());

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      treeDataChildrenField,
      groupDefaultExpanded,
      getRowId,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Tree Data Editable](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/tree-data-editable/vue3/)

## Refreshing Groups After Editing

When grouped columns are editable, setting `refreshAfterGroupEdit=true` causes the grid to update row data and recalculate the grouping after every committed edit. Without this option, the row data updates but the grouping does not get updated until the next full refresh.

When enabling `refreshAfterGroupEdit`, also provide `getRowId` so that the grid can track rows by stable IDs while rebuilding the grouping hierarchy.

The following example demonstrates this behaviour. Double-click on a `department` or `team` cell to edit it; the grid re-evaluates the grouping and moves the row to the correct group instantly.

#### Refresh After Group Edit

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SelectEditorModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  ClientSideRowModelModule,
  TextEditorModule,
  TextFilterModule,
  SelectEditorModule,
]);

interface Employee {
  id: string;
  department: string;
  team: string;
  name: string;
  role: string;
}

const departments = ["Engineering", "Sales", "Marketing"];

const teams: Record<string, string[]> = {
  Engineering: ["Frontend", "Backend", "QA"],
  Sales: ["Enterprise", "SMB", "Partners"],
  Marketing: ["Content", "Growth", "Brand"],
};

const allTeams = Object.values(teams).flat();

function getData(): Employee[] {
  return [
    // Engineering
    {
      id: "1",
      department: "Engineering",
      team: "Frontend",
      name: "Alice",
      role: "Developer",
    },
    {
      id: "2",
      department: "Engineering",
      team: "Frontend",
      name: "Bob",
      role: "Developer",
    },
    {
      id: "3",
      department: "Engineering",
      team: "Backend",
      name: "Carol",
      role: "Developer",
    },
    {
      id: "4",
      department: "Engineering",
      team: "Backend",
      name: "Dave",
      role: "Tech Lead",
    },
    {
      id: "5",
      department: "Engineering",
      team: "QA",
      name: "Eve",
      role: "Tester",
    },
    // Sales
    {
      id: "6",
      department: "Sales",
      team: "Enterprise",
      name: "Frank",
      role: "Account Exec",
    },
    {
      id: "7",
      department: "Sales",
      team: "Enterprise",
      name: "Grace",
      role: "Account Exec",
    },
    {
      id: "8",
      department: "Sales",
      team: "SMB",
      name: "Hank",
      role: "Sales Rep",
    },
    {
      id: "9",
      department: "Sales",
      team: "Partners",
      name: "Ivy",
      role: "Partner Manager",
    },
    // Marketing
    {
      id: "10",
      department: "Marketing",
      team: "Content",
      name: "Jack",
      role: "Writer",
    },
    {
      id: "11",
      department: "Marketing",
      team: "Growth",
      name: "Kim",
      role: "Analyst",
    },
    {
      id: "12",
      department: "Marketing",
      team: "Brand",
      name: "Leo",
      role: "Designer",
    },
  ];
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :autoGroupColumnDef="autoGroupColumnDef"
      :rowData="rowData"
      :refreshAfterGroupEdit="true"
      :groupDefaultExpanded="groupDefaultExpanded"
      :animateRows="true"
      :getRowId="getRowId"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<Employee> | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        field: "department",
        rowGroup: true,
        editable: true,
        cellEditor: "agSelectCellEditor",
        cellEditorParams: { values: departments },
      },
      {
        field: "team",
        rowGroup: true,
        editable: true,
        cellEditor: "agSelectCellEditor",
        cellEditorParams: { values: allTeams },
      },
      { field: "name" },
      { field: "role", editable: true },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      sortable: true,
      resizable: true,
      filter: true,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 250,
    });
    const rowData = ref<Employee[] | null>(getData());
    const groupDefaultExpanded = ref(-1);
    const getRowId = ref<GetRowIdFunc>(({ data }) => data.id);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      rowData,
      groupDefaultExpanded,
      getRowId,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Refresh After Group Edit](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/refresh-after-group-edit/vue3/)

See also [Read Only Edit](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/value-setters/#read-only-edit) for configuring immutable grouped data or connecting the grid with a store.


---
product: "AG Grid"
title: "Row Grouping - Editing Groups"
description: "The grid supports editing grouped data when using the . This page covers making group row cells editable, distributing edited values to descendant rows, and refreshing the grouping hierarchy after edits."
enterprise: true
framework: react
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping/"
    - title: "Grouping Data"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-data/"
    - title: "Group Display Types"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-display-types/"
    - title: "Row Group Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-group-panel/"
    - title: "Expanding Groups"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-opening-groups/"
    - title: "Hierarchy Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-row-selection/"
    - title: "Sorting"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-sorting/"
    - title: "Row Dragging"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-row-dragging/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Row Grouping - Editing Groups

The grid supports editing grouped data when using the [Client-Side Row Model](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-models/#client-side). This page covers making group row cells editable, distributing edited values to descendant rows, and refreshing the grouping hierarchy after edits.

## Editing Group Row Cells

Set `groupRowEditable` on any column to make its group row cells editable. The grid then distributes the edited value to descendant rows using the built-in distribution. To customise this, set `groupRowValueSetter` to an options object, a callback, or `false` to disable distribution.

In the example below, double-click any group row's `Sales` cell to edit it. The new total spreads equally across the group's children, recursing through nested groups.

#### Built-in Sum Distribution

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingEditModule, RowGroupingModule } from "ag-grid-enterprise";
import { SalesRecord, getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<SalesRecord[]>(getData());
  const [columnDefs, setColumnDefs] = useState<(ColDef | ColGroupDef)[]>([
    { field: "region", rowGroup: true, hide: true },
    { field: "country", rowGroup: true, hide: true },
    {
      headerName: "Sales",
      field: "sales",
      aggFunc: "sum",
      editable: true,
      // Enable editing on group rows and use the built-in distribution.
      // With 'sum' aggregation, the default strategy is 'uniform' — the new total
      // is divided equally among all children.
      // precision: 0 rounds values to integers and spreads the rounding remainder
      // across children so the total matches exactly.
      groupRowEditable: true,
      groupRowValueSetter: {
        precision: 0,
      },
    },
  ]);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 220,
      cellRendererParams: { suppressCount: true },
    };
  }, []);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      sortable: true,
      filter: true,
      resizable: true,
    };
  }, []);
  const getRowId = useCallback(({ data }) => data.id, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle} className="ag-theme-quartz">
          <AgGridReact<SalesRecord>
            rowData={rowData}
            columnDefs={columnDefs}
            autoGroupColumnDef={autoGroupColumnDef}
            defaultColDef={defaultColDef}
            groupDefaultExpanded={-1}
            getRowId={getRowId}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Built-in Sum Distribution](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/distribute-group-value-sum/reactFunctionalTs/)

`groupRowEditable` accepts a `boolean` or a callback. The callback runs only for group rows (`rowNode.group === true`); leaf rows continue to honour `editable`. When a column sets both properties, the grid uses whichever matches the current row type, allowing separate rules for group rows and leaf rows.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `groupRowEditable` | `boolean \| GroupRowEditableCallback` |  |  |  |
| `groupRowValueSetter` | `boolean \| GroupRowValueSetterFunc \| GroupRowValueSetterOptions` |  |  |  |

## Built-in Value Distribution

The built-in distribution adjusts each child so the column's `aggFunc` produces the new total. Pass an options object to `groupRowValueSetter` to customise the strategy or precision.

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'sales',
        aggFunc: 'sum',
        editable: true,
        groupRowEditable: true,
        // Built-in distribution: divides the sum equally among children.
        // precision: 0 rounds child values to integers and spreads the remainder.
        groupRowValueSetter: { precision: 0 },
    },
]);

<AgGridReact columnDefs={columnDefs} />
```

### Distribution Strategies

The `distribution` option controls how the edited value is spread across children. When omitted, the strategy is chosen automatically based on the column's `aggFunc`:

| Strategy | Behaviour | Default for |
| --- | --- | --- |
| `'uniform'` | Divides the new value equally among all children. | `sum` |
| `'overwrite'` | Writes the new value directly to every child. | `avg`, no aggFunc |
| `'percentage'` | Scales each child proportionally, preserving relative weights. Falls back to `'uniform'` when the current total is zero. | — |
| `'increment'` | Distributes only the difference (`newValue − oldValue`) among children, adding it to current values. | — |

Editing is **disabled by default** for `count`, `min`, `max`, `first`, `last`, and **custom aggregation functions**. These functions have no unique inverse, so the grid cannot choose a safe default. To enable editing for them:

- Set `distribution` to `'overwrite'` to write the new value directly to every child.
- Provide a per-aggFunc record entry with `'overwrite'`, `true`, or a custom callback (see [Per-Aggregation Strategies](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-edit/#per-aggregation-strategies)).
- Assign a [callback](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-edit/#custom-distribution-with-a-callback) to `groupRowValueSetter` for full control.

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'price',
        aggFunc: 'min',
        editable: true,
        groupRowEditable: true,
        // 'overwrite' writes the edited value to every child
        groupRowValueSetter: { distribution: 'overwrite' },
    },
    {
        field: 'quantity',
        aggFunc: 'count',
        editable: true,
        groupRowEditable: true,
        // Per-aggFunc record: enable only count with overwrite
        groupRowValueSetter: { distribution: { count: 'overwrite' } },
    },
]);

<AgGridReact columnDefs={columnDefs} />
```

Setting `distribution` to `true` uses built-in defaults for `sum`, `avg`, no-aggFunc columns, and custom aggregation functions. The `count`, `min`, `max`, `first`, and `last` functions stay disabled even with `true`; use `'overwrite'`, a per-aggFunc record entry, or a callback to enable them.

Setting `distribution` to `false` or `null` suppresses distribution and makes the cell not editable, even when `groupRowEditable` is `true`.

For `avg`, every strategy adjusts child values so the children's average equals the edited value.

> **Note**
>
> The `precision` option rounds the values written to **child rows**, not the group row's displayed value. The group value is re-computed by the column's `aggFunc` from the rounded children. For `sum` this is always exact. For `avg` the re-aggregated value may differ: distributing `precision: 0` across 3 children produces integers, but their average (`10 / 3 ≈ 3.33`) is not. Use a [Value Formatter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-formatters/) to control how the group row displays the re-aggregated value.

### Distribution Options

Properties available on the `GroupRowValueSetterOptions&lt;TData = any, TValue = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `distribution` | `Distribution` |  |  |  |
| `default` | `GroupRowValueSetterDistributionEntry` |  |  |  |
| `precision` | `number \| false` |  |  |  |
| `getValue` | `Function` |  |  |  |
| `setValue` | `Function` |  |  |  |

### Merging with Default Column Definitions

When `groupRowValueSetter` is set as an options object on both `defaultColDef` and a column, the grid deep merges the two. The column's properties take precedence; anything not specified on the column is inherited from the default. This includes nested `distribution` records.

```jsx
const defaultColDef = useMemo(() => { 
	return {
        editable: true,
        groupRowEditable: true,
        // Default: round child values to integers, disable count
        groupRowValueSetter: { precision: 0, distribution: { count: false } },
    };
}, []);
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'sales',
        aggFunc: 'sum',
        // Column-level override: use percentage distribution.
        // precision: 0 is inherited from defaultColDef.
        groupRowValueSetter: { distribution: 'percentage' },
    },
    {
        field: 'quantity',
        aggFunc: 'count',
        // Override defaultColDef's false with true to enable editing for count.
        groupRowValueSetter: { distribution: { count: true } },
    },
    {
        field: 'profit',
        aggFunc: 'sum',
        // No column-level override — inherits { precision: 0 } from defaultColDef.
    },
]);

<AgGridReact
    defaultColDef={defaultColDef}
    columnDefs={columnDefs}
/>
```

> **Note**
>
> Deep merging only applies when both the `defaultColDef` and the column define `groupRowValueSetter` as plain objects. If the column defines a callback function, it replaces the default entirely.

### Multiple Aggregation Functions

The following example mixes built-in strategies, a non-aggregated column, and custom callbacks. Double-click any group row cell to edit it:

- **Salary** (`sum`): divides the new total equally among children, rounded to integers (`precision: 0`). Editing 300 across 3 children produces 100 each.
- **Bonus** (`avg`): overwrites every child with the edited value. Editing the average to 15 sets all children's bonus to 15.
- **Projects** (no `aggFunc`): overwrites every child with the edited value. The group cell is blank but still editable.
- **Rate %** (custom callback): computes each leaf child's bonus as `salary × rate / 100`. Entering 20 sets each child's bonus to 20% of their salary. Uses `node.getAggregatedChildren(column, true)` to reach all descendant leaf rows directly.
- **SumSq** (custom `sumOfSquares` aggFunc): a callback sets each child to `√(newValue / count)`, the inverse of sum-of-squares.

#### Multiple Aggregation Functions

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GroupRowValueSetterFunc,
  IAggFunc,
  IAggFuncParams,
  IAggFuncs,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingEditModule, RowGroupingModule } from "ag-grid-enterprise";
import { MetricsRecord, getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  TextFilterModule,
];

/** Custom aggregation function: sum of squares. */
const sumOfSquares: IAggFunc = (params: IAggFuncParams) => {
  let total = 0;
  for (const value of params.values) {
    const n = Number(value);
    if (Number.isFinite(n)) {
      total += n * n;
    }
  }
  return total;
};

/**
 * Custom groupRowValueSetter for sumOfSquares.
 *
 * Because sumOfSquares uses x² in its aggregation, the built-in strategies
 * (uniform, percentage, etc.) would not produce correct results.
 * Instead, we compute the square root to find the per-child value that
 * produces the desired aggregate: each child = √(newValue / count).
 */
const sumOfSquaresValueSetter: GroupRowValueSetterFunc<MetricsRecord> = ({
  newValue,
  aggregatedChildren,
  column,
}) => {
  const target = Number(newValue);
  const count = aggregatedChildren.length;
  if (!count || !Number.isFinite(target)) {
    return false;
  }
  const perChild = Math.round(Math.sqrt(Math.max(0, target / count)));
  let changed = false;
  for (const child of aggregatedChildren) {
    if (child.setDataValue(column, perChild, "data")) {
      changed = true;
    }
  }
  return changed;
};

/**
 * Cross-column groupRowValueSetter: editing the group row's "Rate %"
 * sets each leaf child's bonus to a percentage of their individual salary.
 *
 * Uses getAggregatedChildren with recursive=true to reach all descendant
 * leaf rows, since intermediate group rows don't have salary data.
 *
 * For example, entering 20 on the Engineering group sets each engineer's
 * bonus to 20% of their salary: Alice (salary 90) gets bonus 18,
 * Dave (salary 95) gets bonus 19, etc.
 */
const bonusRateSetter: GroupRowValueSetterFunc<MetricsRecord> = ({
  newValue,
  node,
  column,
}) => {
  const rate = Number(newValue) / 100;
  if (!Number.isFinite(rate)) {
    return false;
  }
  const leaves = node.getAggregatedChildren(column, true);
  if (!leaves.length) {
    return false;
  }
  let changed = false;
  for (const child of leaves) {
    const salary = child.data?.salary ?? 0;
    if (child.setDataValue("bonus", Math.round(salary * rate), "data")) {
      changed = true;
    }
  }
  return changed;
};

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<MetricsRecord[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "department", rowGroup: true, hide: true },
    { field: "team", rowGroup: true, hide: true },
    { field: "employee", minWidth: 120 },
    // sum: uniform distribution (divides equally), with integer rounding
    {
      field: "salary",
      aggFunc: "sum",
      groupRowValueSetter: { precision: 0 },
    },
    // avg: default strategy is 'overwrite' — sets every child to the edited value
    {
      field: "bonus",
      aggFunc: "avg",
      valueFormatter: ({ value }) =>
        value != null ? Number(value).toFixed(2) : "",
    },
    // No aggFunc: the default strategy is 'overwrite', writing the edited
    // value to every child. The group cell is blank (no aggregation) but
    // still editable via groupRowEditable.
    { field: "projects" },
    // Cross-column custom callback: editing the group row's "Rate"
    // reads each child's salary and writes a computed bonus.
    {
      headerName: "Rate %",
      valueGetter: ({ data }) =>
        data ? (data.bonus / data.salary) * 100 : null,
      valueFormatter: ({ value }) =>
        value != null ? Number(value).toFixed(2) : "",
      aggFunc: "avg",
      editable: false,
      groupRowEditable: true,
      groupRowValueSetter: bonusRateSetter,
    },
    // Custom aggregation function with a custom groupRowValueSetter
    {
      headerName: "SumSq",
      field: "score",
      aggFunc: "sumOfSquares",
      groupRowValueSetter: sumOfSquaresValueSetter,
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 120,
      sortable: true,
      filter: true,
      resizable: true,
      // Enable editing on all columns (leaf rows and group rows).
      // When groupRowEditable is defined, the built-in distribution
      // automatically uses the right strategy for each aggregation function.
      editable: true,
      groupRowEditable: true,
    };
  }, []);
  const aggFuncs = useMemo<IAggFuncs>(() => {
    return {
      sumOfSquares,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
      cellRendererParams: { suppressCount: true },
    };
  }, []);
  const getRowId = useCallback(({ data }) => data.id, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle} className="ag-theme-quartz">
          <AgGridReact<MetricsRecord>
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            aggFuncs={aggFuncs}
            autoGroupColumnDef={autoGroupColumnDef}
            groupDefaultExpanded={-1}
            getRowId={getRowId}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Multiple Aggregation Functions](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/distribute-group-value-all-agg/reactFunctionalTs/)

### Per-Aggregation Strategies

When several columns share a `groupRowValueSetter` (e.g. via `defaultColDef`) but use different aggregation functions, set `distribution` to a record keyed by `aggFunc` name. Each entry can be a strategy string, an options object, a custom callback, `true` for built-in defaults, or `false`/`null` to suppress distribution for that aggFunc:

```jsx
const myCustomAgg = (params) => {
    let total = 0;
    for (const value of params.values) {
        total += Number(value) || 0;
    }
    return total;
};

// Optional: inverse enables incremental aggregation on row changes
myCustomAgg.inverse = (params) => {
    let total = Number(params.result) || 0;
    for (const value of params.values) {
        total -= Number(value) || 0;
    }
    return total;
};
const aggFuncs = useMemo(() => { 
	return {
        myCustomAgg,
    };
}, []);
const defaultColDef = useMemo(() => { 
	return {
        editable: true,
        groupRowEditable: true,
        groupRowValueSetter: {
            precision: 0,
            distribution: {
                sum: 'percentage',                          // strategy string
                avg: { distribution: 'increment' },         // options object
                myCustomAgg: (params) => {                  // custom callback function
                    for (const child of params.aggregatedChildren) {
                        child.setDataValue(params.column, params.newValue, 'data');
                    }
                    return true;
                },
            },
        },
    };
}, []);

<AgGridReact
    aggFuncs={aggFuncs}
    defaultColDef={defaultColDef}
/>
```

Custom aggregation functions are disabled by default. To enable editing, add an explicit entry in the `distribution` record. The entry can be a strategy string, an options object, or a callback that implements the inverse of the aggregation logic:

```jsx
const defaultColDef = useMemo(() => { 
	return {
        editable: true,
        groupRowEditable: true,
        groupRowValueSetter: {
            precision: 0,
            distribution: {
                sum: 'percentage',
                avg: 'increment',
                count: 'overwrite',
                // Custom aggFunc: provide a callback that reverses the aggregation
                myCustomAgg: (params) => {
                    for (const child of params.aggregatedChildren) {
                        child.setDataValue(params.column, params.newValue, 'data');
                    }
                    return true;
                },
            },
        },
    };
}, []);

<AgGridReact defaultColDef={defaultColDef} />
```

Aggregation functions not listed in the record fall through to the `default` fallback, then to the built-in defaults (see the strategy table above).

### Default Fallback

When multiple custom aggregation functions share the same distribution logic, the `default` property avoids repeating entries for each one. It applies to any aggregation function not explicitly listed in the `distribution` record, including custom aggregations (which are otherwise disabled) and columns with no `aggFunc` (which already default to `'overwrite'`). Non-distributable functions (`count`, `min`, `max`, `first`, `last`) are **not** affected by `default` and must always be listed explicitly.

```jsx
const defaultColDef = useMemo(() => { 
	return {
        editable: true,
        groupRowEditable: true,
        groupRowValueSetter: {
            precision: 0,
            distribution: {
                sum: 'percentage',
                count: 'overwrite',
            },
            // Fallback for unlisted custom aggFuncs and no-aggFunc columns.
            default: 'overwrite',
        },
    };
}, []);

<AgGridReact defaultColDef={defaultColDef} />
```

### Custom getValue and setValue

The `getValue` and `setValue` callbacks override how the built-in distributor reads from and writes to child rows. By default it uses `node.getDataValue(column, 'value')` to read and `node.setDataValue(column, value, 'data')` to write. Provide your own when child values live on a different field or custom data structure, when you need to apply transformations or side effects during distribution, or when the column's `valueGetter` / `valueSetter` are not suitable for distribution.

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'amount',
        aggFunc: 'sum',
        editable: true,
        groupRowEditable: true,
        groupRowValueSetter: {
            distribution: 'percentage',
            getValue: (params) => (params.data && params.data.weight) || 0,
            setValue: (params) => params.node.setDataValue(params.column, params.value, 'data'),
        },
    },
]);

<AgGridReact columnDefs={columnDefs} />
```

## Custom Distribution with a Callback

For full control over how group-level edits cascade, assign a function to `groupRowValueSetter`. The callback receives a `GroupRowValueSetterParams` object and should return `true` when any child value was changed.

The example below distributes the edited total equally among children, rounded to integers (largest remainder method). It calls `setDataValue` on each child; aggregation then refreshes parent totals automatically.

#### Custom Editable Group Totals

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GroupRowValueSetterFunc,
  IsRowFilterable,
  ModuleRegistry,
  NumberFilterModule,
  TextEditorModule,
  ValueParserParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  RowGroupingEditModule,
  RowGroupingModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberFilterModule,
  SetFilterModule,
  TextEditorModule,
];

interface SalesRecord {
  id: string;
  region: string;
  segment: string;
  country: string;
  amount: number;
}

// Parse input to integer
const amountValueParser = (params: ValueParserParams): number | null => {
  const numericValue = Number(params.newValue);
  return Number.isFinite(numericValue)
    ? Math.round(numericValue)
    : (params.oldValue ?? null);
};

/**
 * Distributes a new group total equally among children.
 *
 * `aggregatedChildren` contains the immediate children used for aggregation:
 * - For leaf groups: the data rows
 * - For non-leaf groups: the child groups
 *
 * Calling `setDataValue` on a child group triggers `groupRowValueSetter` again,
 * enabling recursive cascade through the entire group hierarchy.
 */
const cascadeGroupTotal: GroupRowValueSetterFunc<SalesRecord> = ({
  column,
  newValue,
  eventSource,
  aggregatedChildren,
}) => {
  const total = Number(newValue);
  if (!Number.isFinite(total) || !aggregatedChildren.length) {
    return false;
  }
  // Distribute equally among children
  // https://en.wikipedia.org/wiki/Largest_remainder_method
  const count = aggregatedChildren.length;
  const base = Math.floor(total / count);
  let remainder = Math.round(total) - base * count;
  // Apply the distributed values
  let changed = false;
  for (const child of aggregatedChildren) {
    let value = base;
    if (remainder > 0) {
      value++;
      remainder--;
    }
    if (child.setDataValue(column, value, eventSource)) {
      changed = true;
    }
  }
  return changed;
};

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<SalesRecord[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "region", rowGroup: true, hide: true },
    {
      field: "segment",
      rowGroup: true,
      hide: true,
      filter: "agSetColumnFilter",
    },
    { field: "country", filter: "agSetColumnFilter" },
    {
      headerName: "Amount",
      field: "amount",
      aggFunc: "sum",
      editable: true,
      groupRowEditable: true,
      filter: "agNumberColumnFilter",
      valueParser: amountValueParser,
      groupRowValueSetter: cascadeGroupTotal,
    },
  ]);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 260,
      cellRendererParams: {
        suppressCount: true,
      },
    };
  }, []);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      sortable: true,
      filter: true,
      resizable: true,
    };
  }, []);
  const getRowId = useCallback(({ data }) => data.id, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle} className="ag-theme-quartz">
          <AgGridReact<SalesRecord>
            rowData={rowData}
            columnDefs={columnDefs}
            autoGroupColumnDef={autoGroupColumnDef}
            defaultColDef={defaultColDef}
            groupAggFiltering={true}
            groupDefaultExpanded={-1}
            animateRows={true}
            getRowId={getRowId}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Custom Editable Group Totals](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/group-editable-totals-custom/reactFunctionalTs/)

### GroupRowValueSetterParams

Properties available on the `GroupRowValueSetterParams&lt;TData = any, TValue = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |
| `column` | `Column` |  |  |  |
| `colDef` | `ColDef` |  |  |  |
| `oldValue` | `TValue \| null \| undefined` |  |  |  |
| `newValue` | `TValue \| null \| undefined` |  |  |  |
| `node` | `IRowNode` |  |  |  |
| `data` | `TData \| null \| undefined` |  |  |  |
| `eventSource` | `string \| undefined` |  |  |  |
| `valueChanged` | `boolean` |  |  |  |
| `aggregatedChildren` | `IRowNode[]` |  |  |  |

### Aggregated Children

The `groupRowValueSetter` callback receives an `aggregatedChildren` array: the immediate children that contribute to the [Aggregation](https://www.ag-grid.com/archive/36.2.0/react-data-grid/aggregation/) for the edited column. Cascading edits to these children avoids traversing the row hierarchy by hand.

What `aggregatedChildren` returns depends on the column and grid configuration:

- **Regular value columns**: the direct children used for aggregation. This respects `suppressAggFilteredOnly` and `groupAggFiltering`; when those cause aggregation to include all children rather than just filtered ones, `aggregatedChildren` follows suit.
- **Pivot columns on leaf groups**: only the children matching the column's pivot keys, since pivot aggregation groups rows by pivot key values.
- **Non-group rows**: an empty array.

The same children can be retrieved programmatically with `rowNode.getAggregatedChildren(colKey)`. To collect all descendant leaf rows instead of only the immediate children, pass `true` as the second argument: `rowNode.getAggregatedChildren(colKey, true)`.

See [Retrieving Aggregated Children](https://www.ag-grid.com/archive/36.2.0/react-data-grid/aggregation/#retrieving-aggregated-children) for more details.

### Cascading Edits

Key points for implementing cascading edits:

- Call `rowNode.setDataValue` on each child to write the new value down.
- When a child is itself a group with its own `groupRowValueSetter`, the cascade recurses further.
- Parent aggregates refresh automatically: child `data` changes re-run the column `aggFunc`, so editing a group total rebalances the children to match it.
- Aggregation is batched. All `setDataValue` calls within a single `groupRowValueSetter` invocation are processed before re-aggregation runs.

> **Note**
>
> The `aggregatedChildren` parameter and `rowNode.getAggregatedChildren()` method are only supported with the Client-Side Row Model. For other row models, `aggregatedChildren` is an empty array.

### Calling distributeGroupValue

The built-in distribution function `distributeGroupValue` is exported from `ag-grid-enterprise` and can be called directly inside a custom `groupRowValueSetter` callback. This is useful when custom logic is needed before or after the distribution:

```ts
import { distributeGroupValue } from 'ag-grid-enterprise';

colDef.groupRowValueSetter = (params) => {
    // Custom pre-processing
    const adjusted = Math.max(0, Number(params.newValue));
    return distributeGroupValue({ ...params, newValue: adjusted }, { distribution: 'percentage' });
};
```

You can also assign `distributeGroupValue` directly without a wrapper for default behaviour:

```ts
import { distributeGroupValue } from 'ag-grid-enterprise';

colDef.groupRowValueSetter = distributeGroupValue;
```

## Editing Pivot Columns

When using [Pivoting](https://www.ag-grid.com/archive/36.2.0/react-data-grid/pivoting/), the `groupRowValueSetter` also works with pivot result columns. The key difference is that `aggregatedChildren` returns only the children matching the column's pivot keys, not all children of the group.

The following example uses the built-in distribution in pivot mode. Setting `groupRowEditable` enables distribution automatically. Double-click any pivot cell to edit it; the edited value is distributed uniformly among the children matching that pivot column's keys.

#### Built-in Pivot Editing

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  PivotModule,
  RowGroupingEditModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { SalesRecord, getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
  PivotModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<SalesRecord[]>(getData());
  const [columnDefs, setColumnDefs] = useState<(ColDef | ColGroupDef)[]>([
    { field: "region", rowGroup: true, hide: true },
    { field: "country", rowGroup: true, hide: true },
    { field: "product", pivot: true },
    {
      headerName: "Amount",
      field: "amount",
      aggFunc: "sum",
      editable: true,
      // Enable editing on group rows. When groupRowEditable is defined, the
      // built-in distribution is used automatically — 'uniform' for 'sum',
      // dividing the new total equally among children matching the pivot keys.
      groupRowEditable: true,
    },
  ]);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
      cellRendererParams: { suppressCount: true },
    };
  }, []);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 120,
      sortable: true,
      filter: true,
      resizable: true,
    };
  }, []);
  const getRowId = useCallback(({ data }) => data.id, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle} className="ag-theme-quartz">
          <AgGridReact<SalesRecord>
            rowData={rowData}
            columnDefs={columnDefs}
            autoGroupColumnDef={autoGroupColumnDef}
            defaultColDef={defaultColDef}
            pivotMode={true}
            groupDefaultExpanded={-1}
            getRowId={getRowId}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Built-in Pivot Editing](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/pivot-editable-builtin/reactFunctionalTs/)

For full control, use a custom `groupRowValueSetter` callback. In the example below:

- The grid is pivoted by `product` (Electronics, Clothing, Food), grouped by `region` and `country`.
- Double-clicking any pivot column cell opens the editor for the aggregated value.
- When editing a pivot cell (e.g. "Electronics" on the "Europe" row), `aggregatedChildren` contains only the European rows selling Electronics, not all European rows.
- The edit is distributed equally among those matching children, leaving other product categories unchanged.

#### Custom Editable Pivot Totals

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GroupRowValueSetterFunc,
  ModuleRegistry,
  NumberFilterModule,
  SideBarDef,
  TextEditorModule,
  ValueParserParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingEditModule,
  RowGroupingModule,
  SideBarModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberFilterModule,
  TextEditorModule,
  PivotModule,
  SideBarModule,
  ColumnsToolPanelModule,
];

interface SalesRecord {
  id: string;
  region: string;
  country: string;
  product: string;
  amount: number;
}

// Parse input to integer
const amountValueParser = (params: ValueParserParams): number | null => {
  const numericValue = Number(params.newValue);
  return Number.isFinite(numericValue)
    ? Math.round(numericValue)
    : (params.oldValue ?? null);
};

/**
 * Distributes a new pivot total equally among children.
 *
 * In pivot mode, `aggregatedChildren` contains only rows matching the pivot keys.
 * For example, editing the "Electronics 2024" cell returns only rows where
 * product="Electronics" AND year=2024.
 *
 * `setDataValue` on leaf rows with pivot columns auto-resolves to the underlying
 * value column. On group rows, it triggers `groupRowValueSetter` for recursive cascade.
 */
const cascadeGroupTotal: GroupRowValueSetterFunc<SalesRecord> = ({
  column,
  newValue,
  eventSource,
  aggregatedChildren,
}) => {
  const total = Number(newValue);
  if (!Number.isFinite(total) || !aggregatedChildren.length) {
    return false;
  }
  // Distribute equally among children
  // https://en.wikipedia.org/wiki/Largest_remainder_method
  const count = aggregatedChildren.length;
  const base = Math.floor(total / count);
  let remainder = Math.round(total) - base * count;
  // Apply the distributed values
  let changed = false;
  for (const child of aggregatedChildren) {
    let value = base;
    if (remainder > 0) {
      value++;
      remainder--;
    }
    if (child.setDataValue(column, value, eventSource)) {
      changed = true;
    }
  }
  return changed;
};

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<SalesRecord[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "region", rowGroup: true, hide: true },
    { field: "country", rowGroup: true, hide: true },
    { field: "product", pivot: true },
    {
      headerName: "Amount",
      field: "amount",
      aggFunc: "sum",
      editable: true,
      groupRowEditable: true,
      valueParser: amountValueParser,
      groupRowValueSetter: cascadeGroupTotal,
    },
  ]);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
      cellRendererParams: {
        suppressCount: true,
      },
    };
  }, []);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 120,
      sortable: true,
      filter: true,
      resizable: true,
    };
  }, []);
  const getRowId = useCallback(({ data }) => data.id, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle} className="ag-theme-quartz">
          <AgGridReact<SalesRecord>
            rowData={rowData}
            columnDefs={columnDefs}
            autoGroupColumnDef={autoGroupColumnDef}
            defaultColDef={defaultColDef}
            pivotMode={true}
            sideBar={"columns"}
            groupDefaultExpanded={-1}
            getRowId={getRowId}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Custom Editable Pivot Totals](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/pivot-editable-totals-custom/reactFunctionalTs/)

Edits on pivot columns therefore affect only the rows contributing to that pivot value, leaving other pivot categories untouched.

## Tree Data

`groupRowEditable` and `groupRowValueSetter` also work with [Tree Data](https://www.ag-grid.com/archive/36.2.0/react-data-grid/tree-data/). Parent nodes act as group rows, so editing a parent's aggregated value cascades the change down to its children just as with row grouping.

The example below shows a company's budget organised as a tree: departments contain teams, and teams contain employees. Editing a department's or team's budget distributes the new total equally among its members, rounded to integers, recursing through the hierarchy.

#### Tree Data Editable

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingEditModule, TreeDataModule } from "ag-grid-enterprise";
import { BudgetRecord, getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  TreeDataModule,
  RowGroupingEditModule,
  NumberEditorModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<BudgetRecord[]>(getData());
  const [columnDefs, setColumnDefs] = useState<(ColDef | ColGroupDef)[]>([
    {
      headerName: "Budget",
      field: "budget",
      aggFunc: "sum",
      editable: true,
      // Enable editing on group (department/team) rows.
      // The built-in distribution divides the new budget equally among
      // children, cascading through the full tree hierarchy.
      groupRowEditable: true,
      groupRowValueSetter: { precision: 0 },
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      headerName: "Department / Team / Employee",
      field: "name",
      minWidth: 280,
      cellRendererParams: { suppressCount: true },
    };
  }, []);
  const getRowId = useCallback(({ data }) => data.name, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle} className="ag-theme-quartz">
          <AgGridReact<BudgetRecord>
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            autoGroupColumnDef={autoGroupColumnDef}
            treeData={true}
            treeDataChildrenField={"children"}
            groupDefaultExpanded={-1}
            getRowId={getRowId}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Tree Data Editable](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/tree-data-editable/reactFunctionalTs/)

## Refreshing Groups After Editing

When grouped columns are editable, setting `refreshAfterGroupEdit=true` causes the grid to update row data and recalculate the grouping after every committed edit. Without this option, the row data updates but the grouping does not get updated until the next full refresh.

When enabling `refreshAfterGroupEdit`, also provide `getRowId` so that the grid can track rows by stable IDs while rebuilding the grouping hierarchy.

The following example demonstrates this behaviour. Double-click on a `department` or `team` cell to edit it; the grid re-evaluates the grouping and moves the row to the correct group instantly.

#### Refresh After Group Edit

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridOptions,
  ModuleRegistry,
  SelectEditorModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  RowGroupingModule,
  ClientSideRowModelModule,
  TextEditorModule,
  TextFilterModule,
  SelectEditorModule,
];

interface Employee {
  id: string;
  department: string;
  team: string;
  name: string;
  role: string;
}

const departments = ["Engineering", "Sales", "Marketing"];

const teams: Record<string, string[]> = {
  Engineering: ["Frontend", "Backend", "QA"],
  Sales: ["Enterprise", "SMB", "Partners"],
  Marketing: ["Content", "Growth", "Brand"],
};

const allTeams = Object.values(teams).flat();

const getData: () => Employee[] = () => {
  return [
    // Engineering
    {
      id: "1",
      department: "Engineering",
      team: "Frontend",
      name: "Alice",
      role: "Developer",
    },
    {
      id: "2",
      department: "Engineering",
      team: "Frontend",
      name: "Bob",
      role: "Developer",
    },
    {
      id: "3",
      department: "Engineering",
      team: "Backend",
      name: "Carol",
      role: "Developer",
    },
    {
      id: "4",
      department: "Engineering",
      team: "Backend",
      name: "Dave",
      role: "Tech Lead",
    },
    {
      id: "5",
      department: "Engineering",
      team: "QA",
      name: "Eve",
      role: "Tester",
    },
    // Sales
    {
      id: "6",
      department: "Sales",
      team: "Enterprise",
      name: "Frank",
      role: "Account Exec",
    },
    {
      id: "7",
      department: "Sales",
      team: "Enterprise",
      name: "Grace",
      role: "Account Exec",
    },
    {
      id: "8",
      department: "Sales",
      team: "SMB",
      name: "Hank",
      role: "Sales Rep",
    },
    {
      id: "9",
      department: "Sales",
      team: "Partners",
      name: "Ivy",
      role: "Partner Manager",
    },
    // Marketing
    {
      id: "10",
      department: "Marketing",
      team: "Content",
      name: "Jack",
      role: "Writer",
    },
    {
      id: "11",
      department: "Marketing",
      team: "Growth",
      name: "Kim",
      role: "Analyst",
    },
    {
      id: "12",
      department: "Marketing",
      team: "Brand",
      name: "Leo",
      role: "Designer",
    },
  ];
};

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<Employee[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "department",
      rowGroup: true,
      editable: true,
      cellEditor: "agSelectCellEditor",
      cellEditorParams: { values: departments },
    },
    {
      field: "team",
      rowGroup: true,
      editable: true,
      cellEditor: "agSelectCellEditor",
      cellEditorParams: { values: allTeams },
    },
    { field: "name" },
    { field: "role", editable: true },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      sortable: true,
      resizable: true,
      filter: true,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 250,
    };
  }, []);
  const getRowId = useCallback(({ data }) => data.id, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<Employee>
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            autoGroupColumnDef={autoGroupColumnDef}
            refreshAfterGroupEdit={true}
            groupDefaultExpanded={-1}
            animateRows={true}
            getRowId={getRowId}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Refresh After Group Edit](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/refresh-after-group-edit/reactFunctionalTs/)

See also [Read Only Edit](https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-setters/#read-only-edit) for configuring immutable grouped data or connecting the grid with a store.


---
product: "AG Grid"
title: "Row Grouping - Editing Groups"
description: "The grid supports editing grouped data when using the . This page covers making group row cells editable, distributing edited values to descendant rows, and refreshing the grouping hierarchy after edits."
enterprise: true
framework: angular
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping/"
    - title: "Grouping Data"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-data/"
    - title: "Group Display Types"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-display-types/"
    - title: "Row Group Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-group-panel/"
    - title: "Expanding Groups"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-opening-groups/"
    - title: "Hierarchy Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-row-selection/"
    - title: "Sorting"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-sorting/"
    - title: "Row Dragging"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-row-dragging/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Row Grouping - Editing Groups

The grid supports editing grouped data when using the [Client-Side Row Model](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-models/#client-side). This page covers making group row cells editable, distributing edited values to descendant rows, and refreshing the grouping hierarchy after edits.

## Editing Group Row Cells

Set `groupRowEditable` on any column to make its group row cells editable. The grid then distributes the edited value to descendant rows using the built-in distribution. To customise this, set `groupRowValueSetter` to an options object, a callback, or `false` to disable distribution.

In the example below, double-click any group row's `Sales` cell to edit it. The new total spreads equally across the group's children, recursing through nested groups.

#### Built-in Sum Distribution

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingEditModule, RowGroupingModule } from "ag-grid-enterprise";
import { SalesRecord, getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    class="ag-theme-quartz"
    [columnDefs]="columnDefs"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    [groupDefaultExpanded]="groupDefaultExpanded"
    [getRowId]="getRowId"
  /> `,
})
export class AppComponent {
  columnDefs: (ColDef | ColGroupDef)[] = [
    { field: "region", rowGroup: true, hide: true },
    { field: "country", rowGroup: true, hide: true },
    {
      headerName: "Sales",
      field: "sales",
      aggFunc: "sum",
      editable: true,
      // Enable editing on group rows and use the built-in distribution.
      // With 'sum' aggregation, the default strategy is 'uniform' — the new total
      // is divided equally among all children.
      // precision: 0 rounds values to integers and spreads the rounding remainder
      // across children so the total matches exactly.
      groupRowEditable: true,
      groupRowValueSetter: {
        precision: 0,
      },
    },
  ];
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 220,
    cellRendererParams: { suppressCount: true },
  };
  defaultColDef: ColDef = {
    flex: 1,
    sortable: true,
    filter: true,
    resizable: true,
  };
  rowData: SalesRecord[] | null = getData();
  groupDefaultExpanded = -1;
  getRowId: GetRowIdFunc = ({ data }) => data.id;
}
```

[Live example: Built-in Sum Distribution](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/distribute-group-value-sum/angular/)

`groupRowEditable` accepts a `boolean` or a callback. The callback runs only for group rows (`rowNode.group === true`); leaf rows continue to honour `editable`. When a column sets both properties, the grid uses whichever matches the current row type, allowing separate rules for group rows and leaf rows.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `groupRowEditable` | `boolean \| GroupRowEditableCallback` |  |  |  |
| `groupRowValueSetter` | `boolean \| GroupRowValueSetterFunc \| GroupRowValueSetterOptions` |  |  |  |

## Built-in Value Distribution

The built-in distribution adjusts each child so the column's `aggFunc` produces the new total. Pass an options object to `groupRowValueSetter` to customise the strategy or precision.

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'sales',
        aggFunc: 'sum',
        editable: true,
        groupRowEditable: true,
        // Built-in distribution: divides the sum equally among children.
        // precision: 0 rounds child values to integers and spreads the remainder.
        groupRowValueSetter: { precision: 0 },
    },
];
```

### Distribution Strategies

The `distribution` option controls how the edited value is spread across children. When omitted, the strategy is chosen automatically based on the column's `aggFunc`:

| Strategy | Behaviour | Default for |
| --- | --- | --- |
| `'uniform'` | Divides the new value equally among all children. | `sum` |
| `'overwrite'` | Writes the new value directly to every child. | `avg`, no aggFunc |
| `'percentage'` | Scales each child proportionally, preserving relative weights. Falls back to `'uniform'` when the current total is zero. | — |
| `'increment'` | Distributes only the difference (`newValue − oldValue`) among children, adding it to current values. | — |

Editing is **disabled by default** for `count`, `min`, `max`, `first`, `last`, and **custom aggregation functions**. These functions have no unique inverse, so the grid cannot choose a safe default. To enable editing for them:

- Set `distribution` to `'overwrite'` to write the new value directly to every child.
- Provide a per-aggFunc record entry with `'overwrite'`, `true`, or a custom callback (see [Per-Aggregation Strategies](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-edit/#per-aggregation-strategies)).
- Assign a [callback](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-edit/#custom-distribution-with-a-callback) to `groupRowValueSetter` for full control.

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'price',
        aggFunc: 'min',
        editable: true,
        groupRowEditable: true,
        // 'overwrite' writes the edited value to every child
        groupRowValueSetter: { distribution: 'overwrite' },
    },
    {
        field: 'quantity',
        aggFunc: 'count',
        editable: true,
        groupRowEditable: true,
        // Per-aggFunc record: enable only count with overwrite
        groupRowValueSetter: { distribution: { count: 'overwrite' } },
    },
];
```

Setting `distribution` to `true` uses built-in defaults for `sum`, `avg`, no-aggFunc columns, and custom aggregation functions. The `count`, `min`, `max`, `first`, and `last` functions stay disabled even with `true`; use `'overwrite'`, a per-aggFunc record entry, or a callback to enable them.

Setting `distribution` to `false` or `null` suppresses distribution and makes the cell not editable, even when `groupRowEditable` is `true`.

For `avg`, every strategy adjusts child values so the children's average equals the edited value.

> **Note**
>
> The `precision` option rounds the values written to **child rows**, not the group row's displayed value. The group value is re-computed by the column's `aggFunc` from the rounded children. For `sum` this is always exact. For `avg` the re-aggregated value may differ: distributing `precision: 0` across 3 children produces integers, but their average (`10 / 3 ≈ 3.33`) is not. Use a [Value Formatter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-formatters/) to control how the group row displays the re-aggregated value.

### Distribution Options

Properties available on the `GroupRowValueSetterOptions&lt;TData = any, TValue = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `distribution` | `Distribution` |  |  |  |
| `default` | `GroupRowValueSetterDistributionEntry` |  |  |  |
| `precision` | `number \| false` |  |  |  |
| `getValue` | `Function` |  |  |  |
| `setValue` | `Function` |  |  |  |

### Merging with Default Column Definitions

When `groupRowValueSetter` is set as an options object on both `defaultColDef` and a column, the grid deep merges the two. The column's properties take precedence; anything not specified on the column is inherited from the default. This includes nested `distribution` records.

```ts
<ag-grid-angular
    [defaultColDef]="defaultColDef"
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.defaultColDef = {
    editable: true,
    groupRowEditable: true,
    // Default: round child values to integers, disable count
    groupRowValueSetter: { precision: 0, distribution: { count: false } },
};
this.columnDefs = [
    {
        field: 'sales',
        aggFunc: 'sum',
        // Column-level override: use percentage distribution.
        // precision: 0 is inherited from defaultColDef.
        groupRowValueSetter: { distribution: 'percentage' },
    },
    {
        field: 'quantity',
        aggFunc: 'count',
        // Override defaultColDef's false with true to enable editing for count.
        groupRowValueSetter: { distribution: { count: true } },
    },
    {
        field: 'profit',
        aggFunc: 'sum',
        // No column-level override — inherits { precision: 0 } from defaultColDef.
    },
];
```

> **Note**
>
> Deep merging only applies when both the `defaultColDef` and the column define `groupRowValueSetter` as plain objects. If the column defines a callback function, it replaces the default entirely.

### Multiple Aggregation Functions

The following example mixes built-in strategies, a non-aggregated column, and custom callbacks. Double-click any group row cell to edit it:

- **Salary** (`sum`): divides the new total equally among children, rounded to integers (`precision: 0`). Editing 300 across 3 children produces 100 each.
- **Bonus** (`avg`): overwrites every child with the edited value. Editing the average to 15 sets all children's bonus to 15.
- **Projects** (no `aggFunc`): overwrites every child with the edited value. The group cell is blank but still editable.
- **Rate %** (custom callback): computes each leaf child's bonus as `salary × rate / 100`. Entering 20 sets each child's bonus to 20% of their salary. Uses `node.getAggregatedChildren(column, true)` to reach all descendant leaf rows directly.
- **SumSq** (custom `sumOfSquares` aggFunc): a callback sets each child to `√(newValue / count)`, the inverse of sum-of-squares.

#### Multiple Aggregation Functions

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GroupRowValueSetterFunc,
  IAggFunc,
  IAggFuncParams,
  IAggFuncs,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingEditModule, RowGroupingModule } from "ag-grid-enterprise";
import { MetricsRecord, getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  TextFilterModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    class="ag-theme-quartz"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [aggFuncs]="aggFuncs"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [rowData]="rowData"
    [groupDefaultExpanded]="groupDefaultExpanded"
    [getRowId]="getRowId"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "department", rowGroup: true, hide: true },
    { field: "team", rowGroup: true, hide: true },
    { field: "employee", minWidth: 120 },
    // sum: uniform distribution (divides equally), with integer rounding
    {
      field: "salary",
      aggFunc: "sum",
      groupRowValueSetter: { precision: 0 },
    },
    // avg: default strategy is 'overwrite' — sets every child to the edited value
    {
      field: "bonus",
      aggFunc: "avg",
      valueFormatter: ({ value }) =>
        value != null ? Number(value).toFixed(2) : "",
    },
    // No aggFunc: the default strategy is 'overwrite', writing the edited
    // value to every child. The group cell is blank (no aggregation) but
    // still editable via groupRowEditable.
    { field: "projects" },
    // Cross-column custom callback: editing the group row's "Rate"
    // reads each child's salary and writes a computed bonus.
    {
      headerName: "Rate %",
      valueGetter: ({ data }) =>
        data ? (data.bonus / data.salary) * 100 : null,
      valueFormatter: ({ value }) =>
        value != null ? Number(value).toFixed(2) : "",
      aggFunc: "avg",
      editable: false,
      groupRowEditable: true,
      groupRowValueSetter: bonusRateSetter,
    },
    // Custom aggregation function with a custom groupRowValueSetter
    {
      headerName: "SumSq",
      field: "score",
      aggFunc: "sumOfSquares",
      groupRowValueSetter: sumOfSquaresValueSetter,
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 120,
    sortable: true,
    filter: true,
    resizable: true,
    // Enable editing on all columns (leaf rows and group rows).
    // When groupRowEditable is defined, the built-in distribution
    // automatically uses the right strategy for each aggregation function.
    editable: true,
    groupRowEditable: true,
  };
  aggFuncs: IAggFuncs = {
    sumOfSquares,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
    cellRendererParams: { suppressCount: true },
  };
  rowData: MetricsRecord[] | null = getData();
  groupDefaultExpanded = -1;
  getRowId: GetRowIdFunc = ({ data }) => data.id;
}

/** Custom aggregation function: sum of squares. */
const sumOfSquares: IAggFunc = (params: IAggFuncParams) => {
  let total = 0;
  for (const value of params.values) {
    const n = Number(value);
    if (Number.isFinite(n)) {
      total += n * n;
    }
  }
  return total;
};
/**
 * Custom groupRowValueSetter for sumOfSquares.
 *
 * Because sumOfSquares uses x² in its aggregation, the built-in strategies
 * (uniform, percentage, etc.) would not produce correct results.
 * Instead, we compute the square root to find the per-child value that
 * produces the desired aggregate: each child = √(newValue / count).
 */
const sumOfSquaresValueSetter: GroupRowValueSetterFunc<MetricsRecord> = ({
  newValue,
  aggregatedChildren,
  column,
}) => {
  const target = Number(newValue);
  const count = aggregatedChildren.length;
  if (!count || !Number.isFinite(target)) {
    return false;
  }
  const perChild = Math.round(Math.sqrt(Math.max(0, target / count)));
  let changed = false;
  for (const child of aggregatedChildren) {
    if (child.setDataValue(column, perChild, "data")) {
      changed = true;
    }
  }
  return changed;
};
/**
 * Cross-column groupRowValueSetter: editing the group row's "Rate %"
 * sets each leaf child's bonus to a percentage of their individual salary.
 *
 * Uses getAggregatedChildren with recursive=true to reach all descendant
 * leaf rows, since intermediate group rows don't have salary data.
 *
 * For example, entering 20 on the Engineering group sets each engineer's
 * bonus to 20% of their salary: Alice (salary 90) gets bonus 18,
 * Dave (salary 95) gets bonus 19, etc.
 */
const bonusRateSetter: GroupRowValueSetterFunc<MetricsRecord> = ({
  newValue,
  node,
  column,
}) => {
  const rate = Number(newValue) / 100;
  if (!Number.isFinite(rate)) {
    return false;
  }
  const leaves = node.getAggregatedChildren(column, true);
  if (!leaves.length) {
    return false;
  }
  let changed = false;
  for (const child of leaves) {
    const salary = child.data?.salary ?? 0;
    if (child.setDataValue("bonus", Math.round(salary * rate), "data")) {
      changed = true;
    }
  }
  return changed;
};
```

[Live example: Multiple Aggregation Functions](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/distribute-group-value-all-agg/angular/)

### Per-Aggregation Strategies

When several columns share a `groupRowValueSetter` (e.g. via `defaultColDef`) but use different aggregation functions, set `distribution` to a record keyed by `aggFunc` name. Each entry can be a strategy string, an options object, a custom callback, `true` for built-in defaults, or `false`/`null` to suppress distribution for that aggFunc:

```ts
<ag-grid-angular
    [aggFuncs]="aggFuncs"
    [defaultColDef]="defaultColDef"
    /* other grid options ... */ />

const myCustomAgg = (params) => {
    let total = 0;
    for (const value of params.values) {
        total += Number(value) || 0;
    }
    return total;
};

// Optional: inverse enables incremental aggregation on row changes
myCustomAgg.inverse = (params) => {
    let total = Number(params.result) || 0;
    for (const value of params.values) {
        total -= Number(value) || 0;
    }
    return total;
};

this.aggFuncs = {
    myCustomAgg,
};
this.defaultColDef = {
    editable: true,
    groupRowEditable: true,
    groupRowValueSetter: {
        precision: 0,
        distribution: {
            sum: 'percentage',                          // strategy string
            avg: { distribution: 'increment' },         // options object
            myCustomAgg: (params) => {                  // custom callback function
                for (const child of params.aggregatedChildren) {
                    child.setDataValue(params.column, params.newValue, 'data');
                }
                return true;
            },
        },
    },
};
```

Custom aggregation functions are disabled by default. To enable editing, add an explicit entry in the `distribution` record. The entry can be a strategy string, an options object, or a callback that implements the inverse of the aggregation logic:

```ts
<ag-grid-angular
    [defaultColDef]="defaultColDef"
    /* other grid options ... */ />

this.defaultColDef = {
    editable: true,
    groupRowEditable: true,
    groupRowValueSetter: {
        precision: 0,
        distribution: {
            sum: 'percentage',
            avg: 'increment',
            count: 'overwrite',
            // Custom aggFunc: provide a callback that reverses the aggregation
            myCustomAgg: (params) => {
                for (const child of params.aggregatedChildren) {
                    child.setDataValue(params.column, params.newValue, 'data');
                }
                return true;
            },
        },
    },
};
```

Aggregation functions not listed in the record fall through to the `default` fallback, then to the built-in defaults (see the strategy table above).

### Default Fallback

When multiple custom aggregation functions share the same distribution logic, the `default` property avoids repeating entries for each one. It applies to any aggregation function not explicitly listed in the `distribution` record, including custom aggregations (which are otherwise disabled) and columns with no `aggFunc` (which already default to `'overwrite'`). Non-distributable functions (`count`, `min`, `max`, `first`, `last`) are **not** affected by `default` and must always be listed explicitly.

```ts
<ag-grid-angular
    [defaultColDef]="defaultColDef"
    /* other grid options ... */ />

this.defaultColDef = {
    editable: true,
    groupRowEditable: true,
    groupRowValueSetter: {
        precision: 0,
        distribution: {
            sum: 'percentage',
            count: 'overwrite',
        },
        // Fallback for unlisted custom aggFuncs and no-aggFunc columns.
        default: 'overwrite',
    },
};
```

### Custom getValue and setValue

The `getValue` and `setValue` callbacks override how the built-in distributor reads from and writes to child rows. By default it uses `node.getDataValue(column, 'value')` to read and `node.setDataValue(column, value, 'data')` to write. Provide your own when child values live on a different field or custom data structure, when you need to apply transformations or side effects during distribution, or when the column's `valueGetter` / `valueSetter` are not suitable for distribution.

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'amount',
        aggFunc: 'sum',
        editable: true,
        groupRowEditable: true,
        groupRowValueSetter: {
            distribution: 'percentage',
            getValue: (params) => (params.data && params.data.weight) || 0,
            setValue: (params) => params.node.setDataValue(params.column, params.value, 'data'),
        },
    },
];
```

## Custom Distribution with a Callback

For full control over how group-level edits cascade, assign a function to `groupRowValueSetter`. The callback receives a `GroupRowValueSetterParams` object and should return `true` when any child value was changed.

The example below distributes the edited total equally among children, rounded to integers (largest remainder method). It calls `setDataValue` on each child; aggregation then refreshes parent totals automatically.

#### Custom Editable Group Totals

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GroupRowValueSetterFunc,
  IsRowFilterable,
  ModuleRegistry,
  NumberFilterModule,
  TextEditorModule,
  ValueParserParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  RowGroupingEditModule,
  RowGroupingModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberFilterModule,
  SetFilterModule,
  TextEditorModule,
]);

interface SalesRecord {
  id: string;
  region: string;
  segment: string;
  country: string;
  amount: number;
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    class="ag-theme-quartz"
    [columnDefs]="columnDefs"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    [groupAggFiltering]="true"
    [groupDefaultExpanded]="groupDefaultExpanded"
    [animateRows]="true"
    [getRowId]="getRowId"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "region", rowGroup: true, hide: true },
    {
      field: "segment",
      rowGroup: true,
      hide: true,
      filter: "agSetColumnFilter",
    },
    { field: "country", filter: "agSetColumnFilter" },
    {
      headerName: "Amount",
      field: "amount",
      aggFunc: "sum",
      editable: true,
      groupRowEditable: true,
      filter: "agNumberColumnFilter",
      valueParser: amountValueParser,
      groupRowValueSetter: cascadeGroupTotal,
    },
  ];
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 260,
    cellRendererParams: {
      suppressCount: true,
    },
  };
  defaultColDef: ColDef = {
    flex: 1,
    sortable: true,
    filter: true,
    resizable: true,
  };
  rowData: SalesRecord[] | null = getData();
  groupDefaultExpanded = -1;
  getRowId: GetRowIdFunc = ({ data }) => data.id;
}

// Parse input to integer
const amountValueParser = (params: ValueParserParams): number | null => {
  const numericValue = Number(params.newValue);
  return Number.isFinite(numericValue)
    ? Math.round(numericValue)
    : (params.oldValue ?? null);
};
/**
 * Distributes a new group total equally among children.
 *
 * `aggregatedChildren` contains the immediate children used for aggregation:
 * - For leaf groups: the data rows
 * - For non-leaf groups: the child groups
 *
 * Calling `setDataValue` on a child group triggers `groupRowValueSetter` again,
 * enabling recursive cascade through the entire group hierarchy.
 */
const cascadeGroupTotal: GroupRowValueSetterFunc<SalesRecord> = ({
  column,
  newValue,
  eventSource,
  aggregatedChildren,
}) => {
  const total = Number(newValue);
  if (!Number.isFinite(total) || !aggregatedChildren.length) {
    return false;
  }
  // Distribute equally among children
  // https://en.wikipedia.org/wiki/Largest_remainder_method
  const count = aggregatedChildren.length;
  const base = Math.floor(total / count);
  let remainder = Math.round(total) - base * count;
  // Apply the distributed values
  let changed = false;
  for (const child of aggregatedChildren) {
    let value = base;
    if (remainder > 0) {
      value++;
      remainder--;
    }
    if (child.setDataValue(column, value, eventSource)) {
      changed = true;
    }
  }
  return changed;
};
```

[Live example: Custom Editable Group Totals](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/group-editable-totals-custom/angular/)

### GroupRowValueSetterParams

Properties available on the `GroupRowValueSetterParams&lt;TData = any, TValue = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |
| `column` | `Column` |  |  |  |
| `colDef` | `ColDef` |  |  |  |
| `oldValue` | `TValue \| null \| undefined` |  |  |  |
| `newValue` | `TValue \| null \| undefined` |  |  |  |
| `node` | `IRowNode` |  |  |  |
| `data` | `TData \| null \| undefined` |  |  |  |
| `eventSource` | `string \| undefined` |  |  |  |
| `valueChanged` | `boolean` |  |  |  |
| `aggregatedChildren` | `IRowNode[]` |  |  |  |

### Aggregated Children

The `groupRowValueSetter` callback receives an `aggregatedChildren` array: the immediate children that contribute to the [Aggregation](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/aggregation/) for the edited column. Cascading edits to these children avoids traversing the row hierarchy by hand.

What `aggregatedChildren` returns depends on the column and grid configuration:

- **Regular value columns**: the direct children used for aggregation. This respects `suppressAggFilteredOnly` and `groupAggFiltering`; when those cause aggregation to include all children rather than just filtered ones, `aggregatedChildren` follows suit.
- **Pivot columns on leaf groups**: only the children matching the column's pivot keys, since pivot aggregation groups rows by pivot key values.
- **Non-group rows**: an empty array.

The same children can be retrieved programmatically with `rowNode.getAggregatedChildren(colKey)`. To collect all descendant leaf rows instead of only the immediate children, pass `true` as the second argument: `rowNode.getAggregatedChildren(colKey, true)`.

See [Retrieving Aggregated Children](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/aggregation/#retrieving-aggregated-children) for more details.

### Cascading Edits

Key points for implementing cascading edits:

- Call `rowNode.setDataValue` on each child to write the new value down.
- When a child is itself a group with its own `groupRowValueSetter`, the cascade recurses further.
- Parent aggregates refresh automatically: child `data` changes re-run the column `aggFunc`, so editing a group total rebalances the children to match it.
- Aggregation is batched. All `setDataValue` calls within a single `groupRowValueSetter` invocation are processed before re-aggregation runs.

> **Note**
>
> The `aggregatedChildren` parameter and `rowNode.getAggregatedChildren()` method are only supported with the Client-Side Row Model. For other row models, `aggregatedChildren` is an empty array.

### Calling distributeGroupValue

The built-in distribution function `distributeGroupValue` is exported from `ag-grid-enterprise` and can be called directly inside a custom `groupRowValueSetter` callback. This is useful when custom logic is needed before or after the distribution:

```ts
import { distributeGroupValue } from 'ag-grid-enterprise';

colDef.groupRowValueSetter = (params) => {
    // Custom pre-processing
    const adjusted = Math.max(0, Number(params.newValue));
    return distributeGroupValue({ ...params, newValue: adjusted }, { distribution: 'percentage' });
};
```

You can also assign `distributeGroupValue` directly without a wrapper for default behaviour:

```ts
import { distributeGroupValue } from 'ag-grid-enterprise';

colDef.groupRowValueSetter = distributeGroupValue;
```

## Editing Pivot Columns

When using [Pivoting](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/pivoting/), the `groupRowValueSetter` also works with pivot result columns. The key difference is that `aggregatedChildren` returns only the children matching the column's pivot keys, not all children of the group.

The following example uses the built-in distribution in pivot mode. Setting `groupRowEditable` enables distribution automatically. Double-click any pivot cell to edit it; the edited value is distributed uniformly among the children matching that pivot column's keys.

#### Built-in Pivot Editing

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  PivotModule,
  RowGroupingEditModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { SalesRecord, getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberEditorModule,
  NumberFilterModule,
  TextFilterModule,
  PivotModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    class="ag-theme-quartz"
    [columnDefs]="columnDefs"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [defaultColDef]="defaultColDef"
    [pivotMode]="true"
    [rowData]="rowData"
    [groupDefaultExpanded]="groupDefaultExpanded"
    [getRowId]="getRowId"
  /> `,
})
export class AppComponent {
  columnDefs: (ColDef | ColGroupDef)[] = [
    { field: "region", rowGroup: true, hide: true },
    { field: "country", rowGroup: true, hide: true },
    { field: "product", pivot: true },
    {
      headerName: "Amount",
      field: "amount",
      aggFunc: "sum",
      editable: true,
      // Enable editing on group rows. When groupRowEditable is defined, the
      // built-in distribution is used automatically — 'uniform' for 'sum',
      // dividing the new total equally among children matching the pivot keys.
      groupRowEditable: true,
    },
  ];
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
    cellRendererParams: { suppressCount: true },
  };
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 120,
    sortable: true,
    filter: true,
    resizable: true,
  };
  rowData: SalesRecord[] | null = getData();
  groupDefaultExpanded = -1;
  getRowId: GetRowIdFunc = ({ data }) => data.id;
}
```

[Live example: Built-in Pivot Editing](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/pivot-editable-builtin/angular/)

For full control, use a custom `groupRowValueSetter` callback. In the example below:

- The grid is pivoted by `product` (Electronics, Clothing, Food), grouped by `region` and `country`.
- Double-clicking any pivot column cell opens the editor for the aggregated value.
- When editing a pivot cell (e.g. "Electronics" on the "Europe" row), `aggregatedChildren` contains only the European rows selling Electronics, not all European rows.
- The edit is distributed equally among those matching children, leaving other product categories unchanged.

#### Custom Editable Pivot Totals

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GroupRowValueSetterFunc,
  ModuleRegistry,
  NumberFilterModule,
  SideBarDef,
  TextEditorModule,
  ValueParserParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingEditModule,
  RowGroupingModule,
  SideBarModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  RowGroupingEditModule,
  ClientSideRowModelModule,
  NumberFilterModule,
  TextEditorModule,
  PivotModule,
  SideBarModule,
  ColumnsToolPanelModule,
]);

interface SalesRecord {
  id: string;
  region: string;
  country: string;
  product: string;
  amount: number;
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    class="ag-theme-quartz"
    [columnDefs]="columnDefs"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [defaultColDef]="defaultColDef"
    [pivotMode]="true"
    [sideBar]="sideBar"
    [rowData]="rowData"
    [groupDefaultExpanded]="groupDefaultExpanded"
    [getRowId]="getRowId"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "region", rowGroup: true, hide: true },
    { field: "country", rowGroup: true, hide: true },
    { field: "product", pivot: true },
    {
      headerName: "Amount",
      field: "amount",
      aggFunc: "sum",
      editable: true,
      groupRowEditable: true,
      valueParser: amountValueParser,
      groupRowValueSetter: cascadeGroupTotal,
    },
  ];
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
    cellRendererParams: {
      suppressCount: true,
    },
  };
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 120,
    sortable: true,
    filter: true,
    resizable: true,
  };
  sideBar: SideBarDef | string | string[] | boolean | null = "columns";
  rowData: SalesRecord[] | null = getData();
  groupDefaultExpanded = -1;
  getRowId: GetRowIdFunc = ({ data }) => data.id;
}

// Parse input to integer
const amountValueParser = (params: ValueParserParams): number | null => {
  const numericValue = Number(params.newValue);
  return Number.isFinite(numericValue)
    ? Math.round(numericValue)
    : (params.oldValue ?? null);
};
/**
 * Distributes a new pivot total equally among children.
 *
 * In pivot mode, `aggregatedChildren` contains only rows matching the pivot keys.
 * For example, editing the "Electronics 2024" cell returns only rows where
 * product="Electronics" AND year=2024.
 *
 * `setDataValue` on leaf rows with pivot columns auto-resolves to the underlying
 * value column. On group rows, it triggers `groupRowValueSetter` for recursive cascade.
 */
const cascadeGroupTotal: GroupRowValueSetterFunc<SalesRecord> = ({
  column,
  newValue,
  eventSource,
  aggregatedChildren,
}) => {
  const total = Number(newValue);
  if (!Number.isFinite(total) || !aggregatedChildren.length) {
    return false;
  }
  // Distribute equally among children
  // https://en.wikipedia.org/wiki/Largest_remainder_method
  const count = aggregatedChildren.length;
  const base = Math.floor(total / count);
  let remainder = Math.round(total) - base * count;
  // Apply the distributed values
  let changed = false;
  for (const child of aggregatedChildren) {
    let value = base;
    if (remainder > 0) {
      value++;
      remainder--;
    }
    if (child.setDataValue(column, value, eventSource)) {
      changed = true;
    }
  }
  return changed;
};
```

[Live example: Custom Editable Pivot Totals](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/pivot-editable-totals-custom/angular/)

Edits on pivot columns therefore affect only the rows contributing to that pivot value, leaving other pivot categories untouched.

## Tree Data

`groupRowEditable` and `groupRowValueSetter` also work with [Tree Data](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tree-data/). Parent nodes act as group rows, so editing a parent's aggregated value cascades the change down to its children just as with row grouping.

The example below shows a company's budget organised as a tree: departments contain teams, and teams contain employees. Editing a department's or team's budget distributes the new total equally among its members, rounded to integers, recursing through the hierarchy.

#### Tree Data Editable

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingEditModule, TreeDataModule } from "ag-grid-enterprise";
import { BudgetRecord, getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  TreeDataModule,
  RowGroupingEditModule,
  NumberEditorModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    class="ag-theme-quartz"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [treeData]="true"
    [treeDataChildrenField]="treeDataChildrenField"
    [groupDefaultExpanded]="groupDefaultExpanded"
    [getRowId]="getRowId"
    [rowData]="rowData"
  /> `,
})
export class AppComponent {
  columnDefs: (ColDef | ColGroupDef)[] = [
    {
      headerName: "Budget",
      field: "budget",
      aggFunc: "sum",
      editable: true,
      // Enable editing on group (department/team) rows.
      // The built-in distribution divides the new budget equally among
      // children, cascading through the full tree hierarchy.
      groupRowEditable: true,
      groupRowValueSetter: { precision: 0 },
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    headerName: "Department / Team / Employee",
    field: "name",
    minWidth: 280,
    cellRendererParams: { suppressCount: true },
  };
  treeDataChildrenField = "children";
  groupDefaultExpanded = -1;
  getRowId: GetRowIdFunc = ({ data }) => data.name;
  rowData: BudgetRecord[] | null = getData();
}
```

[Live example: Tree Data Editable](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/tree-data-editable/angular/)

## Refreshing Groups After Editing

When grouped columns are editable, setting `refreshAfterGroupEdit=true` causes the grid to update row data and recalculate the grouping after every committed edit. Without this option, the row data updates but the grouping does not get updated until the next full refresh.

When enabling `refreshAfterGroupEdit`, also provide `getRowId` so that the grid can track rows by stable IDs while rebuilding the grouping hierarchy.

The following example demonstrates this behaviour. Double-click on a `department` or `team` cell to edit it; the grid re-evaluates the grouping and moves the row to the correct group instantly.

#### Refresh After Group Edit

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SelectEditorModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowGroupingModule,
  ClientSideRowModelModule,
  TextEditorModule,
  TextFilterModule,
  SelectEditorModule,
]);

interface Employee {
  id: string;
  department: string;
  team: string;
  name: string;
  role: string;
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [rowData]="rowData"
    [refreshAfterGroupEdit]="true"
    [groupDefaultExpanded]="groupDefaultExpanded"
    [animateRows]="true"
    [getRowId]="getRowId"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      field: "department",
      rowGroup: true,
      editable: true,
      cellEditor: "agSelectCellEditor",
      cellEditorParams: { values: departments },
    },
    {
      field: "team",
      rowGroup: true,
      editable: true,
      cellEditor: "agSelectCellEditor",
      cellEditorParams: { values: allTeams },
    },
    { field: "name" },
    { field: "role", editable: true },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    sortable: true,
    resizable: true,
    filter: true,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 250,
  };
  rowData: Employee[] | null = getData();
  groupDefaultExpanded = -1;
  getRowId: GetRowIdFunc = ({ data }) => data.id;
}

const departments = ["Engineering", "Sales", "Marketing"];
const teams: Record<string, string[]> = {
  Engineering: ["Frontend", "Backend", "QA"],
  Sales: ["Enterprise", "SMB", "Partners"],
  Marketing: ["Content", "Growth", "Brand"],
};
const allTeams = Object.values(teams).flat();
function getData(): Employee[] {
  return [
    // Engineering
    {
      id: "1",
      department: "Engineering",
      team: "Frontend",
      name: "Alice",
      role: "Developer",
    },
    {
      id: "2",
      department: "Engineering",
      team: "Frontend",
      name: "Bob",
      role: "Developer",
    },
    {
      id: "3",
      department: "Engineering",
      team: "Backend",
      name: "Carol",
      role: "Developer",
    },
    {
      id: "4",
      department: "Engineering",
      team: "Backend",
      name: "Dave",
      role: "Tech Lead",
    },
    {
      id: "5",
      department: "Engineering",
      team: "QA",
      name: "Eve",
      role: "Tester",
    },
    // Sales
    {
      id: "6",
      department: "Sales",
      team: "Enterprise",
      name: "Frank",
      role: "Account Exec",
    },
    {
      id: "7",
      department: "Sales",
      team: "Enterprise",
      name: "Grace",
      role: "Account Exec",
    },
    {
      id: "8",
      department: "Sales",
      team: "SMB",
      name: "Hank",
      role: "Sales Rep",
    },
    {
      id: "9",
      department: "Sales",
      team: "Partners",
      name: "Ivy",
      role: "Partner Manager",
    },
    // Marketing
    {
      id: "10",
      department: "Marketing",
      team: "Content",
      name: "Jack",
      role: "Writer",
    },
    {
      id: "11",
      department: "Marketing",
      team: "Growth",
      name: "Kim",
      role: "Analyst",
    },
    {
      id: "12",
      department: "Marketing",
      team: "Brand",
      name: "Leo",
      role: "Designer",
    },
  ];
}
```

[Live example: Refresh After Group Edit](https://www.ag-grid.com/archive/36.2.0/examples/grouping-edit/refresh-after-group-edit/angular/)

See also [Read Only Edit](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-setters/#read-only-edit) for configuring immutable grouped data or connecting the grid with a store.
